# $Header:   //ARCHIVE/PVCSROOT/Archive_NLS/Scripts/SetupHealthMonitor.ksv   1.0   Jul 23 2001 15:38:16   Forthman  $

# This is necessary for Health Monitor Services Setup from the patch.

print "\n***************************************************"
print "*Health Monitor Services Setup for TBSM 1.5 patch.*"
print "***************************************************\n"

#Setting the proper path for the shell
print "\nSetting shell path."
print "\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-"

shellpath=$(which sh)
rc=$(reg update "HKLM\\System\\CurrentControlSet\\Services\\ASIHealthMonitor\\Parameters\\Application=$shellpath" 2>&1)
if $(print "$rc" | grep -q "The operation completed successfully."); then;
else
  print "There was a problem with configuring the shellpath: $rc"
fi

#Creating the value for the MVS Sender Services host
print "\nConfiguring to monitor Sender Services."
print "\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-"

print "Please enter the name of the Health Monitor Server -->"
read HMSServer
print "Please enter the location of the MVS Sender Services host -->"
read SenderServicesHost

rc=$(reg add "HKLM\\Software\\Accessible Software, Inc.\\Access1\\1.0\\Health Monitor\\Profiles\\$HMSServer\\Hosts\\SenderServices=$SenderServicesHost" 2>&1)
if $(print "$rc" | grep -q "The registry value already exists"); then;
  rc=$(reg update "HKLM\\Software\\Accessible Software, Inc.\\Access1\\1.0\\Health Monitor\\Profiles\\$HMSServer\\Hosts\\SenderServices=$SenderServicesHost" 2>&1)
fi
if $(print "$rc" | grep -q "The operation completed successfully."); then;
else
  print "There was a problem with configuring to monitor the Sender Services: $rc"
fi


#Unloading current Required Services list
print "\nUnloading the Required Services list."
print "\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-"

rc=$(echo 'y' | REG DEL 'HKEY_LOCAL_MACHINE\SOFTWARE\Accessible Software, Inc.\Access1\1.0\Health Monitor\Profiles\Default Services' 2>&1)

if $(print "$rc" | grep -q "Permanentely delete"); then;
elif $(print "$rc" | grep -q "The system was unable to find the specified registry key"); then;
else
  print "ERROR: $rc"
fi


#Unloading current Default View Definitions
print "\nUnloading the Default View Definitions."
print "\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-"

rc=$(echo 'y' | REG DEL 'HKEY_LOCAL_MACHINE\SOFTWARE\Accessible Software, Inc.\Access1\1.0\Health Monitor\Profiles\Default View Definitions' 2>&1)

if $(print "$rc" | grep -q "Permanentely delete"); then;
elif $(print "$rc" | grep -q "The system was unable to find the specified registry key"); then;
else
  print "ERROR: $rc"
fi


#Reloading the Required Services list and Default View Definitions
print "\nReloading Required Services list and Default View Definitions."
print "\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-"

echo 'HKEY_LOCAL_MACHINE\SOFTWARE\Accessible Software, Inc.\Access1\1.0\Health Monitor
    Profiles
        Default View Definitions
            Database Blocks
                Abbreviation = BLK
                Caption = Database Blocking
                FileName = GetDBBlocks.txt
            Database Lock Summary
                Abbreviation = LOCK
                Caption = Database Lock Summary
                FileName = GetDBLockSummary.txt
            DB Queue Status
                Abbreviation = DBQ
                Caption = DB Queues
                FileName = DumpDBQueues.txt
            MVS Status
                Abbreviation = MVS
                Caption = MVS Status
                FileName = GetMVSStatus.txt
            PAgent Status
                Abbreviation = PA
                Caption = PAgent Status
                FileName = GetPAgentStatus.txt
            Required Services
                Abbreviation = SVC
                Caption = Required Services
                FileName = MonitorRequiredServices.txt
            Server Disk Usage
                Abbreviation = DISK
                Caption = Server Disk Usage
                FileName = CalcDiskUsageAll.txt
            SQL Response Times
                Abbreviation = RESP
                Caption = SQL Response Times
                FileName = GetSQLResponseTimes.txt
            Staged Event Status
                Abbreviation = SES
                Caption = Staged Event Status
                FileName = StagedEventStatus.txt
        Default Services
            Tivoli BSM 1.1.1 Application Serv
                DesiredState = RUNNING
                Host = $ASHost
                Service = ASIApplicationSvcV2.1.6.7
            Tivoli BSM 1.1.1 Notification Server
                DesiredState = RUNNING
                Host = $ASHost
                Service = ASINotificationSvcV2.1.6.7
            Tivoli BSM Agent Listener
                DesiredState = RUNNING
                Host = $DBHost
                Service = ASIAgentListenerSvc
            Tivoli BSM Application Server
                DesiredState = RUNNING
                Host = $ASHost
                Service = ASIApplicationSvc
            Tivoli BSM Batch Rule Server
                DesiredState = RUNNING
                Host = $DBHost
                Service = ASIBatchRuleSvc
            Tivoli BSM Console Server
                DesiredState = RUNNING
                Host = $ASHost
                Service = ASIConsoleServer
            Tivoli BSM Database Validater - Host DB
                DesiredState = RUNNING
                Host = $DBHost
                Service = ASIDBValidater
            Tivoli BSM Database Validater - Host History
                DesiredState = RUNNING
                Host = $HistoryHost
                Service = ASIDBValidater
            Tivoli BSM Database Validater - Host AS
                DesiredState = RUNNING
                Host = $ASHost
                Service = ASIDBValidater
            Tivoli BSM Database Validater - Host PA
                DesiredState = RUNNING
                Host = $PAHost
                Service = ASIDBValidater
            Tivoli BSM Database Validater - Host MVS
                DesiredState = RUNNING
                Host = $MVSHost
                Service = ASIDBValidater
            Tivoli BSM Enqueue Proxy Server - Host PA
                DesiredState = RUNNING
                Host = $PAHost
                Service = ASIEnqueueProxyServer
            Tivoli BSM Enqueue Proxy Server - Host MVS
                DesiredState = RUNNING
                Host = $MVSHost
                Service = ASIEnqueueProxyServer
            Tivoli BSM Event Enablement
                DesiredState = RUNNING
                Host = $DBHost
                Service = ASIEventEnablement
            Tivoli BSM MVSIPListener
                DesiredState = RUNNING
                Host = $DBHost
                Service = ASIMVSIPListenerSvc
            Tivoli BSM MVSIPOSListener
                DesiredState = RUNNING
                Host = $MVSHost
                Service = ASIMVSIPOSListenerSvc
            Tivoli BSM MVSUpload Rule Server
                DesiredState = RUNNING
                Host = $MVSHost
                Service = ASIMVSUploadRuleSvc
            Tivoli BSM Notification Server
                DesiredState = RUNNING
                Host = $DBHost
                Service = ASINotificationSvc
            Tivoli BSM Propagation Agent Dispatcher
                DesiredState = RUNNING
                Host = $DBHost
                Service =ASIPADispatcher
            Tivoli BSM Remote Execution Server - Host MVS
                DesiredState = RUNNING
                Host = $MVSHost
                Service = ASIRemoteExecutionServer
            Tivoli BSM Remote Execution Server - Host PA
                DesiredState = RUNNING
                Host = $PAHost
                Service = ASIRemoteExecutionServer
            Tivoli BSM Staged Event Loader
                DesiredState = RUNNING
                Host = $DBHost
                Service = ASIStagedEventLoader
            Tivoli BSM Task Server
                DesiredState = RUNNING
                Host = $DBHost
                Service = ASITaskServer
            Tivoli BSM TSD Event Handler
                DesiredState = RUNNING
                Host = $DBHost
                Service = ASITSDEventHandlerSvc' >> "$0.reg"

# apply the generated file
if [ -f "$0.reg" ]; then;
  regini "$0.reg" > nul:
  rm -f "$0.reg" 2> nul:
fi


#Configuring the Health Monitor Service
print "\nConfiguring the Health Monitor Service."
print "\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-"

flag=0

while [[ $flag -ne 1 ]]
do

  print 'To install the service, you need a username / password combination\nthat has administrative access to the Health Monitor Server (this computer)\nand to the TBSM Servers.\n'
  print 'Please enter the DomainName\Username -->'
  read -r username
  print 'Please enter the corresponding password -->'
  read password

  rc=$(sc create ASITestingService binPath= \\testingwithnonexistantfile.exe type= own DisplayName= "Testing - delete when done!" obj= $username password= $password 2>&1)
  if $(print "$rc" | grep -q "SUCCESS"); then;
    rc=$(sc delete ASITestingService 2>&1)
    rc2=$(sc config ASIHealthMonitor start= auto obj= $username password= $password 2>&1)
  else
    print 'Username / password combination incorrect! Try again.\n\n'
  fi
  if $(print "$rc2" | grep -q "SUCCESS"); then;
      flag=1

      #Starting the service
      print "\nStarting the Health Monitor service."
      print "\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-\-"

      rc3=$(sc start ASIHealthMonitor 2>&1)
  else
    print "There was a problem with configuring the Health Monitor: $rc2"
  fi
done

flag2=0

while [[ $flag2 -ne 1 ]]
do
  if $(print "$rc3" | grep -q "RUNNING"); then;
    print "\nDone!\n"
    flag2=1
  elif $(print "$rc3" | grep -q "START_PENDING"); then;
    rc3=$(sc query ASIHealthMonitor)
  elif $(print "$rc3" | grep -q "1056"); then;
    rc=$(sc stop ASIHealthMonitor 2>&1)
    rc=$(sc start ASIHealthMonitor 2>&1)

    if $(print "$rc" | grep -q "RUNNING"); then;
      print "\nDone!\n"
      flag2=1
    elif $(print "$rc" | grep -q "START_PENDING"); then;
      rc3=$(sc query ASIHealthMonitor)
    else
      print "\nAn error occured starting the Health Monitor Service: $rc\n"
      flag2=1 
    fi
  else
    print "\nAn error occured starting the Health Monitor Service: $rc3\n"
    flag2=1
  fi
done
