#!/bin/sh
# This script adds a new LOB under a parent LOB (existing/new)

function usage {
  ASIShellMsg ASILobScripts 1 "$1" >&2
  ASIShellMsg ASILobScripts 6 >&2
}

plob=""
pkey=""
lob=""
server=""
userid=""
password=""

while getopts p:l:k:S:U:P: o
do
  if [ $o = p ]
  then
    plob=$OPTARG
  elif [ $o = l ]
  then
    lob=$OPTARG
  elif [ $o = k ]
  then
    pkey=$OPTARG
  elif [ $o = S ]
  then
    server=$OPTARG
  elif [ $o = U ]
  then
    userid=$OPTARG
  elif [ $o = P ]
  then
    password=$OPTARG
  else
    usage $0
    exit 1
  fi
done

. gemargs.sh

if [ "x$lob" = x -o "x$server" = x -o "x$userid" = x -o "x$password" = x ] 
then
  usage $0
  exit 1
fi

if [ ! "$plob" ]
then
  plob='LOBC'
fi

if ! tbsmsql.exe -n -MCONSOLE -X -w 500 -S "$server" -U "$userid" -P "$password" -d Object -Q "exec gemsp_addLOB N'$lob', N'$plob', N'$pkey'" -o addLOB.out
then 
  ASIShellMsg ASILobScripts 2 "tbsmsql.exe -MCONSOLE call - exec gemsp_addLOB N'$lob', N'$plob', N'$pkey'. Look at addLOB.out for details"
  exit 1     
fi

if [ -f "addLOB.out" ]
then
  grep "TBSM.*:" addLOB.out
fi 

ASIShellMsg ASILobScripts 3




