#!/bin/sh
# This script adds a component (product-version) into a LOB (existing/new)

function usage {
  ASIShellMsg ASILobScripts 5 "$1" >&2
  ASIShellMsg ASILobScripts 7 >&2
  ASIShellMsg ASILobScripts 8 >&2
}

product=""
version=""
lob=""
lkey=""
server=""
userid=""
password=""
option=""
pattern=""
expression=""
test=""
action="insert"

while getopts p:v:l:k:S:U:P:o:n:e:t:a: z
do
  if [ $z = p ]
  then
    product=$OPTARG
  elif [ $z = v ]
  then
    version=$OPTARG
  elif [ $z = l ]
  then
    lob=$OPTARG
  elif [ $z = k ]
  then
    lkey=$OPTARG
  elif [ $z = o ]
  then
    option=$OPTARG
  elif [ $z = n ]
  then
    pattern=$OPTARG
  elif [ $z = e ]
  then
    expression=$OPTARG
  elif [ $z = t ]
  then
    test=$OPTARG
  elif [ $z = S ]
  then
    server=$OPTARG
  elif [ $z = U ]
  then
    userid=$OPTARG
  elif [ $z = P ]
  then
    password=$OPTARG
  elif [ $z = a ]
  then
    action=$OPTARG
  else
    usage $0
    exit 1
  fi
done

. gemargs.sh

# Invalid when BOTH product & version (as cname can be in one of them) are empty
if [ "x$product" = x -a "x$version" = x ] 
then
  usage $0
  exit 1
fi

if [ "x$server" = x -o "x$userid" = x -o "x$password" = x ] 
then
  usage $0
  exit 1
fi

if [ "x$lob" = x -a "x$lkey" = x ] 
then
  usage $0
  exit 1
fi

if [ "$action" != "insert" -a "$action" != "update" -a "$action" != "delete" ]
then
  action="insert"
fi

if [ "x$option" = x -a "x$pattern" = x -a "x$expression" = x -a "x$test" = x ]
then
  if ! tbsmsql.exe -n -MCONSOLE -X -w 500 -S "$server" -U "$userid" -P "$password" -d Object -Q "exec gemsp_addpvToLOB @product=N'$product', @version=N'$version', @loblabel=N'$lob', @lobkey=N'$lkey', @action=N'$action'" -o addpvToLOB.out
  then
    ASIShellMsg ASILobScripts 2 "tbsmsql.exe -MCONSOLE call - exec gemsp_addpvToLOB @product=N'$product', @version=N'$version', @loblabel=N'$lob', @lobkey=N'$lkey', @action=N'$action'. Look at addpvToLOB.out for details"
    exit 1     
  fi
else
  if ! tbsmsql.exe -n -MCONSOLE -X -w 500 -S "$server" -U "$userid" -P "$password" -d Object -Q "exec gemsp_addpvToLOB N'$product', N'$version', N'$lob', N'$lkey', N'$option', N'$pattern', N'$expression', N'$test', N'$action'" -o addpvToLOB.out
  then
    ASIShellMsg ASILobScripts 2 "tbsmsql.exe -MCONSOLE call - exec gemsp_addpvToLOB N'$product', N'$version', N'$lob', N'$lkey', N'$option', N'$pattern', N'$expression', N'$test', N'$action'. Look at addpvToLOB.out for details"
    exit 1     
  fi
fi

if [ -f "addpvToLOB.out" ]
then
  grep "TBSM.*:" addpvToLOB.out
fi 

ASIShellMsg ASILobScripts 3

