#!/bin/sh
# This script removes a LOB

function usage {
  ASIShellMsg ASILobScripts 4 "$1" >&2
}

server=""
userid=""
password=""
lob=""
plob="LOBC"

while getopts p:l:S:U:P: z
do
  if [ $z = p ]
  then
    plob=$OPTARG
  elif [ $z = l ]
  then
    lob=$OPTARG
  elif [ $z = S ]
  then
    server=$OPTARG
  elif [ $z = U ]
  then
    userid=$OPTARG
  elif [ $z = P ]
  then
    password=$OPTARG
  else
    usage $0
    exit 1
  fi
done

. gemargs.sh

if [ "x$plob" = x -o "x$lob" = x -o "x$server" = x -o "x$userid" = x -o "x$password" = x ] 
then
  usage $0
  exit 1
fi

if ! tbsmsql.exe -MCONSOLE -X -w 500 -S "$server" -U "$userid" -P "$password" -d Object -Q "exec gemsp_rmLOB N'$lob', N'$plob'" -o rmLOB.out
then
  ASIShellMsg ASILobScripts 2 "tbsmsql.exe -MCONSOLE call - exec gemsp_rmLOB N'$lob', N'$plob'. Look at rmLOB.out for details"
  exit 1     
fi

if [ -f "rmLOB.out" ]
then
  grep "TBSM.*:" rmLOB.out
fi 
 
rm -rf rmLOB.out

ASIShellMsg ASILobScripts 3

