#!/bin/sh
# This script removes a LOB

function usage {
  ASIShellMsg ASILobScripts 13 "$1" >&2
  ASIShellMsg ASILobScripts 14 >&2
  ASIShellMsg ASILobScripts 11 >&2
}

server=""
userid=""
password=""
prod=""
ver=""
pprod=""
pver=""
pmatch=""
pname=""
plobid="0"
name=""

while getopts S:U:P:p:v:l:i:w:d:N:V: z
do
  if [ $z = p ]
  then
    prod=$OPTARG
  elif [ $z = v ]
  then
    ver=$OPTARG
  elif [ $z = N ]
  then
    pprod=$OPTARG
  elif [ $z = V ]
  then
    pver=$OPTARG
  elif [ $z = l ]
  then
    pname=$OPTARG
  elif [ $z = i ]
  then
    plobid=$OPTARG
  elif [ $z = w ]
  then
    pmatch=$OPTARG
  elif [ $z = d ]
  then
    name=$OPTARG    
  elif [ $z = S ]
  then
    server=$OPTARG
  elif [ $z = U ]
  then
    userid=$OPTARG
  elif [ $z = P ]
  then
    password=$OPTARG
  else
    usage $0
    exit 1
  fi
done

. gemargs.sh

# Invalid when BOTH product & version (as cname can be in one of them) are empty
if [ "x$prod" = x -a "x$ver" = x ] 
then
  usage $0
  exit 1
fi

if [ "x$pprod" = x -a "x$pver" = x ] 
then
  usage $0
  exit 1
fi

if [ "x$server" = x -o "x$userid" = x -o "x$password" = x ] 
then
  usage $0
  exit 1
fi

# Check if $plobid is a number
if ! expr "$plobid" : '[0-9][0-9]*$' > /dev/null 2>&1
then
  ASIShellMsg ASILobScripts 12 "$plobid" >&2
  usage $0
  exit 1
fi

if [ "x$pmatch" = x -a "x$pname" = x -a "$plobid" = "0" ] 
then
  usage $0
  exit 1
fi

# Escape single-quote in $pmatch 
pmatch=$(echo "$pmatch" | sed -e "s/'/''/g")

if ! tbsmsql.exe -n -MCONSOLE -X -w 500 -S "$server" -U "$userid" -P "$password" -d Object -Q "exec gemsp_rmLOBInst N'$prod', N'$ver', N'$pprod', N'$pver', N'$pmatch', N'$pname', N'$plobid', N'$name'" -o rmLOBInst.out
then
  ASIShellMsg ASILobScripts 2 "tbsmsql.exe - exec gemsp_rmLOBInst N'$prod', N'$ver', N'$pprod', N'$pver', N'$pmatch', N'$pname', N'$plobid', N'$name'"
  exit 1     
fi

if [ -f "rmLOBInst.out" ]
then
  grep "TBSM.*:" rmLOBInst.out
fi 
 
















