#!/bin/sh
# This script update LOB view

function usage {
  ASIShellMsg ASILobScripts 15 "$1" >&2
}

server=""
userid=""
password=""

while getopts S:U:P: z
do
  if [ $z = S ]
  then
    server=$OPTARG
  elif [ $z = U ]
  then
    userid=$OPTARG
  elif [ $z = P ]
  then
    password=$OPTARG
  else
    usage $0
    exit 1
  fi
done

. gemargs.sh

if [ "x$server" = x -o "x$userid" = x -o "x$password" = x ] 
then
  usage $0
  exit 1
fi

# Call gemsp_updateLOBview to update LOB view with the changes recently added
if ! tbsmsql.exe -n -MCONSOLE -X -w 500 -S "$server" -U "$userid" -P "$password" -d Object -Q "exec gemsp_updateLOBviews" -o updateLOBview.out
then
  ASIShellMsg ASILobScripts 2 "tbsmsql.exe - exec gemsp_updateLOBviews"
  exit 1     
fi

if [ -f "updateLOBview.out" ]
then
  grep "TBSM.*:" updateLOBview.out
fi 


