#!/bin/sh

function usage {
  ASIShellMsg ASILobScripts 16 "$1" >&2
}

product=""
version=""
pname=""
server=""
userid=""
password=""

while getopts p:v:l:S:U:P: z
do
  if [ $z = p ]
  then
    product=$OPTARG
  elif [ $z = v ]
  then
    version=$OPTARG
  elif [ $z = l ]
  then
    pname=$OPTARG
  elif [ $z = S ]
  then
    server=$OPTARG
  elif [ $z = U ]
  then
    userid=$OPTARG
  elif [ $z = P ]
  then
    password=$OPTARG
  else
    usage $0
    exit 1
  fi
done

. gemargs.sh

# Invalid when BOTH product & version (as cname can be in one of them) are empty
if [ "x$product" = x -a "x$version" = x ] 
then
  usage $0
  exit 1
fi

if [ "x$server" = x -o "x$userid" = x -o "x$password" = x ] 
then
  usage $0
  exit 1
fi

if ! tbsmsql.exe -n -MCONSOLE -X -w 500 -S "$server" -U "$userid" -P "$password" -d Object -Q "exec gemsp_viewLOBInfo @product=N'$product', @version=N'$version', @pname=N'$pname'" -o viewLOBInfo.out
then
  ASIShellMsg ASILobScripts 2 "tbsmsql.exe - exec gemsp_viewLOBInfo @product=N'$product', @version=N'$version', @pname=N'$pname'"
  exit 1     
fi

if [ -f "viewLOBInfo.out" ]
then
  grep "TBSM.*:" viewLOBInfo.out
fi 



