(deffunction str-replace
   (?find ?replace ?datastring)
   (bind ?offset (str-index ?find ?datastring))
   (if (neq ?offset FALSE)
      then
      (bind ?returnstring (sub-string 1 (- ?offset 1) ?datastring))
      (bind ?returnstring (str-cat ?returnstring ?replace))
      (bind ?leftoverstring (sub-string (+ ?offset (str-length ?find)) (str-length ?datastring) ?datastring))
      (if (> (str-length ?leftoverstring) 0)
         then
         (bind ?returnstring (str-cat ?returnstring (str-replace ?find ?replace ?leftoverstring))))
      else
      (bind ?returnstring ?datastring))
   (return ?returnstring))
(deffunction SetProcessedEvent  ())
(deffunction SetShutdownEvent	())


(defrule APM_CONNECTION_EXIST_ID "Identify a APMConnectionChange Msg"
 ?fact <- (APMConnection ?handle ?sourcehostid ?sourcecomponentid ?messageid ?headertimestamp ?headertimestampval ?processid ?threadid ?category ?priority ?messageversion ?timingsversion ?class ?gemis_hostname ?origin ?suborigin ?source ?subsource	?relationship ?direction ?apmsource ?apmsubsource ?apmorigin ?apmsuborigin 	?apmhostname ?apmchange ?eventtime )
=>
 (bind ?dberr (ExecStoredProc gemsp_processAPMConnectionChangeMsg
 		?class
		?gemis_hostname 
		?origin
		?suborigin
		?source 
		?subsource 
		?relationship 
		?direction
		?apmsource 
		?apmsubsource 
		?apmorigin
		?apmsuborigin 
		?apmhostname
		?apmchange
		?eventtime


	)
 )

; debugging output for use with interactive rule engine
  (printout t "APM_CONNECTION_EXIST_ID: Sample DEBUG output in APMConnection.clp" ?messageid tab ?gemis_hostname ", timestamp=[" ?headertimestamp "]" crlf)

  ; cleanup memory used by the fact
  (retract ?fact)

 ; Shutdown if returned dberr is less than 0 and
 ; not a duplicate key violation (-2601, -2615, ...) 
 (if (and  (< ?dberr 0) 
           (<> ?dberr -2601) (<> ?dberr -2615) (<> ?dberr -2626) 
           (<> ?dberr -2627) (<> ?dberr -3604) (<> ?dberr -3605) (<> ?dberr -10007)
     )
   then
     (SetShutdownEvent)
   else
     (SetProcessedEvent)
 )
) 

