(deffunction str-replace
   (?find ?replace ?datastring)
   (bind ?offset (str-index ?find ?datastring))
   (if (neq ?offset FALSE)
      then
      (bind ?returnstring (sub-string 1 (- ?offset 1) ?datastring))
      (bind ?returnstring (str-cat ?returnstring ?replace))
      (bind ?leftoverstring (sub-string (+ ?offset (str-length ?find)) (str-length ?datastring) ?datastring))
      (if (> (str-length ?leftoverstring) 0)
         then
         (bind ?returnstring (str-cat ?returnstring (str-replace ?find ?replace ?leftoverstring))))
      else
      (bind ?returnstring ?datastring))
   (return ?returnstring))
(deffunction SetProcessedEvent  ())
(deffunction SetShutdownEvent	())


(defrule APM_THRESHOLD_EXIST_ID "Identify a APMThreshold Msg"
 ?fact <- (APMThreshold ?handle ?sourcehostid ?sourcecomponentid ?messageid ?headertimestamp ?headertimestampval ?processid ?threadid ?category ?priority ?messageversion ?timingsversion ?class ?gemis_hostname ?origin ?suborigin ?source ?subsource ?adapterhost ?probeid ?probeargs ?probevalue ?probelabel ?severity ?mgednode ?eehost ?hostOS ?epttcphost ?tmrid ?eventtime )
=>
 (bind ?dberr (ExecStoredProc gemsp_processAPMThresholdMsg
        ?class 
		?gemis_hostname 
		?origin 
		?suborigin 
		?source 
		?subsource 
		?adapterhost 
		?probeid 
		?probeargs 
		?probevalue 
		?probelabel 
		?severity 
		?mgednode 
		?eehost
		?hostOS
		?epttcphost
		?tmrid
		?eventtime

	)
 )

; debugging output for use with interactive rule engine
  (printout t "APM_THRESHOLD_EXIST_ID: Sample DEBUG output in APMThreshold.clp" ?messageid tab ?gemis_hostname ", timestamp=[" ?headertimestamp "]" crlf)

  ; cleanup memory used by the fact
  (retract ?fact)

 ; Shutdown if returned dberr is less than 0 and
 ; not a duplicate key violation (-2601, -2615, ...) 
 (if (and  (< ?dberr 0) 
           (<> ?dberr -2601) (<> ?dberr -2615) (<> ?dberr -2626) 
           (<> ?dberr -2627) (<> ?dberr -3604) (<> ?dberr -3605) (<> ?dberr -10007)
     )
   then
     (SetShutdownEvent)
   else
     (SetProcessedEvent)
 )
) 



