SET NOCOUNT ON
USE Object

/*** Created by Karl McCormick ***/

/****** Object:  Table [dbo].[CL_Registration]    Script Date: 7/22/01 1:25:09 PM ******/
if exists (select * from sysobjects where id = object_id(N'[dbo].[CL_Registration]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CL_Registration]
GO

/****** Object:  Table [dbo].[CL_RegistrationInstance]    Script Date: 7/22/01 1:25:09 PM ******/
if exists (select * from sysobjects where id = object_id(N'[dbo].[CL_RegistrationInstance]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CL_RegistrationInstance]
GO

/****** Object:  Table [dbo].[CL_RegistrationInstanceCkPt]    Script Date: 7/22/01 1:25:09 PM ******/
if exists (select * from sysobjects where id = object_id(N'[dbo].[CL_RegistrationInstanceCkPt]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CL_RegistrationInstanceCkPt]
GO

/****** Object:  Table [dbo].[CL_RegistrationList]    Script Date: 7/22/01 1:25:09 PM ******/
if exists (select * from sysobjects where id = object_id(N'[dbo].[CL_RegistrationList]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CL_RegistrationList]
GO

/****** Object:  Table [dbo].[CL_Stage]    Script Date: 7/22/01 1:25:09 PM ******/
if exists (select * from sysobjects where id = object_id(N'[dbo].[CL_Stage]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CL_Stage]
GO

/****** Object:  Table [dbo].[CL_StageBulkData]    Script Date: 7/22/01 1:25:09 PM ******/
if exists (select * from sysobjects where id = object_id(N'[dbo].[CL_StageBulkData]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CL_StageBulkData]
GO

/****** Object:  Table [dbo].[CL_StageDeltaData]    Script Date: 7/22/01 1:25:09 PM ******/
if exists (select * from sysobjects where id = object_id(N'[dbo].[CL_StageDeltaData]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CL_StageDeltaData]
GO

/****** Object:  Table [dbo].[CL_StageEvData]    Script Date: 7/22/01 1:25:09 PM ******/
if exists (select * from sysobjects where id = object_id(N'[dbo].[CL_StageEvData]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CL_StageEvData]
GO

/****** Object:  Table [dbo].[CL_Registration]    Script Date: 7/22/01 1:26:06 PM ******/
CREATE TABLE [dbo].[CL_Registration] (
	[registrationId] [int] IDENTITY (1, 1) NOT NULL ,
	[instrId] [nvarchar] (255) NOT NULL ,
	[instrAddress] [nvarchar] (255) NOT NULL ,
	[sid] [nvarchar] (255) NOT NULL
) ON [PRIMARY]
GO

/****** Object:  Table [dbo].[CL_RegistrationInstance]    Script Date: 7/22/01 1:26:10 PM ******/
CREATE TABLE [dbo].[CL_RegistrationInstance] (
	[sidId] [int] IDENTITY (1, 1) NOT NULL ,
	[registrationId] [int] NOT NULL ,
	[state] [tinyint] NOT NULL ,
	[supportBulk] [bit] NOT NULL ,
	[supportDelta] [bit] NOT NULL ,
	[supportAtWill] [bit] NOT NULL ,
	[supportEvents] [bit] NOT NULL ,
	[supportMethods] [bit] NOT NULL ,
	[dateChange] [datetime] NOT NULL
) ON [PRIMARY]
GO

/****** Object:  Table [dbo].[CL_RegistrationInstanceCkPt]    Script Date: 7/22/01 1:26:11 PM ******/
CREATE TABLE [dbo].[CL_RegistrationInstanceCkPt] (
	[sidId] [int] NOT NULL ,
	[registrationId] [int] NOT NULL ,
	[trId] [int] NOT NULL ,
	[eventCount] [int] NOT NULL ,
	[trType] [int] NOT NULL ,
	[msgTr] [int] NOT NULL ,
	[msgNum] [int] NOT NULL ,
	[msgNumFinished] [int] NOT NULL ,
	[trInProgress] [bit] NOT NULL ,
	[trSafe] [bit] NOT NULL ,
	[longRunCount] [int] NOT NULL ,
	[aoc] [int] NOT NULL ,
	[doc] [int] NOT NULL ,
	[moc] [int] NOT NULL ,
	[alc] [int] NOT NULL ,
	[dlc] [int] NOT NULL ,
	[ec] [int] NOT NULL ,
	[state] [tinyint] NOT NULL ,
	[supportBulk] [bit] NOT NULL ,
	[supportDelta] [bit] NOT NULL ,
	[supportAtWill] [bit] NOT NULL ,
	[supportEvents] [bit] NOT NULL ,
	[supportMethods] [bit] NOT NULL ,
	[dateChange] [datetime] NOT NULL
) ON [PRIMARY]
GO

/****** Object:  Table [dbo].[CL_RegistrationList]    Script Date: 7/22/01 1:26:13 PM ******/
CREATE TABLE [dbo].[CL_RegistrationList] (
	[registrationId] [int] NOT NULL ,
	[type] [tinyint] NOT NULL ,
	[cid] [ClassID] NULL
) ON [PRIMARY]
GO

/****** Object:  Table [dbo].[CL_Stage]    Script Date: 7/22/01 1:26:14 PM ******/
CREATE TABLE [dbo].[CL_Stage] (
	[trId] [int] IDENTITY (1, 1) NOT NULL ,
	[registrationId] [int] NOT NULL ,
	[trType] [tinyint] NOT NULL ,
	[trState] [tinyint] NOT NULL ,
	[msgTrID] [int] NOT NULL ,
	[msgNumberBegin] [int] NOT NULL ,
	[msgNumberEnd] [int] NOT NULL ,
	[trTimeReceived] [datetime] NOT NULL ,
	[trTimeCommitted] [datetime] NULL ,
	[trEventCount] [int] NOT NULL ,
	[addObjCount] [int] NOT NULL ,
	[delObjCount] [int] NOT NULL ,
	[modObjCount] [int] NOT NULL ,
	[addLinkCount] [int] NOT NULL ,
	[delLinkCount] [int] NOT NULL ,
	[evCount] [int] NOT NULL
) ON [PRIMARY]
GO

/****** Object:  Table [dbo].[CL_StageBulkData]    Script Date: 7/22/01 1:26:16 PM ******/
CREATE TABLE [dbo].[CL_StageBulkData] (
	[trId] [int] NOT NULL ,
	[evDataId] [int] NOT NULL ,
	[action] [tinyint] NOT NULL ,
	[root] [nvarchar] (512) NOT NULL ,
	[keyword] [nvarchar] (64) NOT NULL ,
	[value] [nvarchar] (255) NOT NULL
) ON [PRIMARY]
GO

/****** Object:  Table [dbo].[CL_StageDeltaData]    Script Date: 7/22/01 1:26:16 PM ******/
CREATE TABLE [dbo].[CL_StageDeltaData] (
	[trId] [int] NOT NULL ,
	[evDataId] [int] NOT NULL ,
	[action] [tinyint] NOT NULL ,
	[root] [nvarchar] (512) NOT NULL ,
	[keyword] [nvarchar] (64) NOT NULL ,
	[value] [nvarchar] (255) NOT NULL
) ON [PRIMARY]
GO

/****** Object:  Table [dbo].[CL_StageEvData]    Script Date: 7/22/01 1:26:17 PM ******/
CREATE TABLE [dbo].[CL_StageEvData] (
	[trId] [int] NOT NULL ,
	[evDataId] [int] NOT NULL ,
	[root] [nvarchar] (512) NOT NULL ,
	[keyword] [nvarchar] (64) NOT NULL ,
	[value] [nvarchar] (255) NOT NULL
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[CL_Registration] WITH NOCHECK ADD
	CONSTRAINT [DF_CL_Registration_sid] DEFAULT (0) FOR [sid],
	CONSTRAINT [PK_CL_Registration] PRIMARY KEY  NONCLUSTERED
	(
		[registrationId]
	)  ON [PRIMARY]
GO

ALTER TABLE [dbo].[CL_RegistrationInstance] WITH NOCHECK ADD
	CONSTRAINT [DF_CL_RegistrationInstance_state] DEFAULT (1) FOR [state],
	CONSTRAINT [DF_CL_RegistrationInstance_dateChange] DEFAULT (getdate()) FOR [dateChange]
GO

ALTER TABLE [dbo].[CL_RegistrationInstanceCkPt] WITH NOCHECK ADD
	CONSTRAINT [DF_CL_RegistrationState_trId] DEFAULT (0) FOR [trId],
	CONSTRAINT [DF_CL_RegistrationState_eventCount] DEFAULT (0) FOR [eventCount],
	CONSTRAINT [DF_CL_RegistrationState_trType] DEFAULT (0) FOR [trType],
	CONSTRAINT [DF_CL_RegistrationState_msgTr] DEFAULT (0) FOR [msgTr],
	CONSTRAINT [DF_CL_RegistrationState_msgNum] DEFAULT (0) FOR [msgNum],
	CONSTRAINT [DF_CL_RegistrationInstance_msgNumFinished] DEFAULT (0) FOR [msgNumFinished],
	CONSTRAINT [DF_CL_RegistrationInstance_trInProgress] DEFAULT (0) FOR [trInProgress],
	CONSTRAINT [DF_CL_RegistrationInstance_trSafe] DEFAULT (1) FOR [trSafe],
	CONSTRAINT [DF_CL_RegistrationInstance_longRunCount] DEFAULT (0) FOR [longRunCount],
	CONSTRAINT [DF_CL_RegistrationState_aoc] DEFAULT (0) FOR [aoc],
	CONSTRAINT [DF_CL_RegistrationState_doc] DEFAULT (0) FOR [doc],
	CONSTRAINT [DF_CL_RegistrationState_moc] DEFAULT (0) FOR [moc],
	CONSTRAINT [DF_CL_RegistrationState_alc] DEFAULT (0) FOR [alc],
	CONSTRAINT [DF_CL_RegistrationState_dlc] DEFAULT (0) FOR [dlc],
	CONSTRAINT [DF_CL_RegistrationState_ec] DEFAULT (0) FOR [ec],
	CONSTRAINT [DF_CL_RegistrationState_state] DEFAULT (1) FOR [state],
	CONSTRAINT [DF_CL_RegistrationState_dateChange] DEFAULT (getdate()) FOR [dateChange]
GO

ALTER TABLE [dbo].[CL_Stage] WITH NOCHECK ADD
	CONSTRAINT [DF_CL_Stage_trState] DEFAULT (2) FOR [trState],
	CONSTRAINT [DF_CL_Stage_msgNumberFirst] DEFAULT (0) FOR [msgNumberBegin],
	CONSTRAINT [DF_CL_Stage_msgNumberLast] DEFAULT (0) FOR [msgNumberEnd],
	CONSTRAINT [DF_CL_Stage_trTimeReceived] DEFAULT (getdate()) FOR [trTimeReceived],
	CONSTRAINT [DF_CL_Stage_trEventCount] DEFAULT (0) FOR [trEventCount],
	CONSTRAINT [DF_CL_Stage_trAddObjCount] DEFAULT (0) FOR [addObjCount],
	CONSTRAINT [DF_CL_Stage_trDelObjCount] DEFAULT (0) FOR [delObjCount],
	CONSTRAINT [DF_CL_Stage_trModObjCount] DEFAULT (0) FOR [modObjCount],
	CONSTRAINT [DF_CL_Stage_trAddLinkCount] DEFAULT (0) FOR [addLinkCount],
	CONSTRAINT [DF_CL_Stage_trDelLinkCount] DEFAULT (0) FOR [delLinkCount],
	CONSTRAINT [DF_CL_Stage_trEvCount] DEFAULT (0) FOR [evCount]
GO

ALTER TABLE [dbo].[CL_StageBulkData] WITH NOCHECK ADD
	CONSTRAINT [DF_CL_StageBulkData_action] DEFAULT (1) FOR [action]
GO

ALTER TABLE [dbo].[CL_StageDeltaData] WITH NOCHECK ADD
	CONSTRAINT [DF_CL_StageDeltaData_action] DEFAULT (1) FOR [action]
GO


/*** Created by Radhikha Myneni ***/
-----------------------------------------------------------

PRINT 'Creating table CL_Status'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name='CL_Status' and type='U')
  DROP TABLE CL_Status
GO

CREATE TABLE [dbo].[CL_Status] (
	[trId] [int] NOT NULL ,
	[evDataId] [int] NOT NULL ,
	[status] [nvarchar] (8) NOT NULL ,
	[disposition] [varchar] (8000) NOT NULL,
        [time] [datetime] NOT NULL
) ON [PRIMARY]
GO

-----------------------------------------------------------

PRINT 'Creating table CL_IDCache'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name='CL_IDCache' and type='U')
  DROP TABLE CL_IDCache
GO

CREATE TABLE CL_IDCache (
  oid  ObjID PRIMARY KEY(keyword,value,cid,oid),
  cid ClassID,
  keyword NVARCHAR(32),
  value NVARCHAR(412),
  instrID NVARCHAR(255),
  time DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
  deleted TINYINT DEFAULT 0
)
GO

------------------------------------------------------------

PRINT 'Creating table CL_AutoPlacement'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name='CL_AutoPlacement' and type='U')
  DROP TABLE CL_AutoPlacement
GO

CREATE TABLE CL_AutoPlacement (
  name NVARCHAR(128) PRIMARY KEY(name, seq),
  _in NVARCHAR(128) NOT NULL,
  _out NVARCHAR(128) NOT NULL,
  seq INT
)
GO

-- Maps Instrumentation to a Enterprise
INSERT CL_AutoPlacement SELECT 'CLInstrumentation_to_ENT', '%[Tt][Nn][Gg]%', 'TNG', 1
INSERT CL_AutoPlacement SELECT 'CLInstrumentation_to_ENT', '%[Nn][Ee][Tt][Vv][Ii][Ee][Ww]%', 'NetView', 2
INSERT CL_AutoPlacement SELECT 'CLInstrumentation_to_ENT', '%', 'Your Company, Inc.', 3

/*
-- Maps IPNetwork to Enterprise
INSERT CL_AutoPlacement SELECT 'IPNetwork_to_ENT', '%.%.%.%', '{2:-3}', 1
INSERT CL_AutoPlacement SELECT 'IPNetwork_to_ENT', '%', 'Your Company, Inc.', 2

-- Maps NetworkSubnet to IPNetwork
INSERT CL_AutoPlacement SELECT 'NetworkSubnet_to_IPNetwork', '%.%.%.%', '{2:-3}', 1
INSERT CL_AutoPlacement SELECT 'NetworkSubnet_to_IPNetwork', '%', 'Discovered', 2
*/
GO

----------------------------------------------------------------

PRINT 'Creating table CL_Severities'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name='CL_Severities' and type='U')
  DROP TABLE CL_Severities
GO

CREATE TABLE CL_Severities (
  name NVARCHAR(64) PRIMARY KEY(name, severity),
  severity NVARCHAR(32),
  alertState INT,
  priority INT
)
GO

-- GEM Severities
INSERT CL_Severities SELECT 'tec', 'normal', 1, 5
INSERT CL_Severities SELECT 'tec', 'harmless', 1, 4
INSERT CL_Severities SELECT 'tec', 'informational', 1, 4
INSERT CL_Severities SELECT 'tec', 'unknown', 2, 5
INSERT CL_Severities SELECT 'tec', 'minor', 2, 4
INSERT CL_Severities SELECT 'tec', 'warning', 2, 3
INSERT CL_Severities SELECT 'tec', 'severe', 3, 3
INSERT CL_Severities SELECT 'tec', 'critical', 3, 2
INSERT CL_Severities SELECT 'tec', 'fatal', 3, 1

-- NetView Severities
INSERT CL_Severities SELECT 'nvd', 'unknown', 1, 5
INSERT CL_Severities SELECT 'nvd', 'normal', 1, 5
INSERT CL_Severities SELECT 'nvd', 'marginal', 2, 3
INSERT CL_Severities SELECT 'nvd', 'critical', 3, 1
INSERT CL_Severities SELECT 'nvd', 'unmanaged', 1, 5
INSERT CL_Severities SELECT 'nvd', 'acknowledged', 1, 5
INSERT CL_Severities SELECT 'nvd', 'user1', 1, 5
INSERT CL_Severities SELECT 'nvd', 'user2', 2, 3
INSERT CL_Severities SELECT 'nvd', 'unreachable', 1, 5

-- TNG Severities
INSERT CL_Severities SELECT 'tng', 'unknown', 2, 5
INSERT CL_Severities SELECT 'tng', 'normal', 1, 5
INSERT CL_Severities SELECT 'tng', 'minor', 2, 4
INSERT CL_Severities SELECT 'tng', 'major', 2, 2
INSERT CL_Severities SELECT 'tng', 'warning', 2, 3
INSERT CL_Severities SELECT 'tng', 'critical', 3, 2
INSERT CL_Severities SELECT 'tng', 'inservice', 1, 4
INSERT CL_Severities SELECT 'tng', 'down', 3, 1
INSERT CL_Severities SELECT 'tng', 'remove', 2, 5
INSERT CL_Severities SELECT 'tng', 'future', 2, 5

GO

----------------------------------------------------------------

PRINT 'Creating table CL_Scheduled_SPCalls'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name='CL_Scheduled_SPCalls' and type='U')
  DROP TABLE CL_Scheduled_SPCalls
GO

CREATE TABLE CL_Scheduled_SPCalls (
  sp_call NVARCHAR(3500),
  state TINYINT DEFAULT 0,
  disposition NVARCHAR(512) DEFAULT '',
  timestp TIMESTAMP
)
GO

----------------------------------------------------------------

PRINT 'Creating table CL_Options'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name='CL_Options' and type='U')
  DROP TABLE CL_Options
GO

CREATE TABLE CL_Options (
  _Option NVARCHAR(128) PRIMARY KEY(_Option, _Value),
  _Value NVARCHAR(128)
)
GO

INSERT CL_Options SELECT 'cleanup interval in hours', '12'

----------------------------------------------------------------

PRINT 'Creating table CL_Store'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name='CL_Store' and type='U')
  DROP TABLE CL_Store
GO

CREATE TABLE CL_Store (
  trId INT NOT NULL,
  evDataId INT NOT NULL,
  action TINYINT NOT NULL,
  root NVARCHAR(512) NOT NULL,
  keyword NVARCHAR(64) NOT NULL,
  value NVARCHAR(255) NOT NULL,
)
GO

----------------------------------------------------------------

PRINT 'Creating table CL_ModifiedClasses'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name='CL_ModifiedClasses' and type='U')
  DROP TABLE CL_ModifiedClasses
GO

CREATE TABLE CL_ModifiedClasses (
  cid ClassID PRIMARY KEY(cid),
  time DATETIME DEFAULT CURRENT_TIMESTAMP
)

GO
----------------------------------------------------------------

-- Defining Jobs in CommonListener
USE msdb
GO

-- Create job to kick-off cl_processNextTrans
IF EXISTS (SELECT * FROM sysjobs WHERE name = 'CLProcessNextTransactionJob')
  EXEC sp_delete_job @job_name='CLProcessNextTransactionJob'

/*
EXEC sp_add_job @job_name='CLProcessNextTransactionJob', @enabled=1

-- Create a single step within the job
EXEC sp_add_jobstep @job_name='CLProcessNextTransactionJob',
                    @step_name='CLProcessNextTransactionJobStep1',
                    @command='cl_processNextTrans',
		    @output_file_name='[SQLDIR]\Log\CLProcessNextTrans.log',
		    @on_success_action=3, @on_fail_action=3, -- Go to next step.
                    @database_name='Object',@server=@@SERVERNAME

EXEC sp_add_jobstep @job_name='CLProcessNextTransactionJob',
                    @step_name='CLProcessNextTransactionJobStep2',
                    @command='sp_start_job @job_name="CLScheduled_SPCallsJob"',
                    @database_name='msdb',@server=@@SERVERNAME

-- Associate the job with a server
EXEC sp_add_jobserver @job_name='CLProcessNextTransactionJob', @server_name=@@SERVERNAME

-- Schedule to call job every 5 minutes
EXEC sp_add_jobschedule @name='CLProcessNextTransaction'
    ,@job_name='CLProcessNextTransactionJob'
    ,@freq_type=4		-- run daily
    ,@freq_interval=1		-- run every day (as opposed to every 2 days, etc.)
    ,@freq_subday_type=4	-- indicates that the sub-day frequency is expressed in minutes (4=minutes, 8=hours)
    ,@freq_subday_interval=5	-- the number of "subday_type" periods (minutes or hours) between each execution
*/
--GO

/*
-- To call the JOB now

USE msdb
EXEC sp_start_job @job_name='CLProcessNextTransactionJob'

*/

----------------------------------------------------------------

-- Define 'Distributed Resource Monitoring' category if one doesnt exist
IF NOT EXISTS (SELECT * FROM syscategories WHERE name = 'Distributed Resource Monitoring')
  EXEC sp_add_category @name='Distributed Resource Monitoring'

-- Create job to do Clean-up every 30mts
IF EXISTS (SELECT * FROM sysjobs WHERE name = 'CLCleanUpJob')
  EXEC sp_delete_job @job_name='CLCleanUpJob'

EXEC sp_add_job @job_name='CLCleanUpJob',
	     	@category_name='Distributed Resource Monitoring',
		@enabled=1

-- Create a single step within the job
EXEC sp_add_jobstep @job_name='CLCleanUpJob',
                    @step_name='CLCleanUpJobStep',
                    @command='cl_cleanUp',
		    @output_file_name='[SQLDIR]\Log\CLCleanUp.log',
                    @database_name='Object',@server=@@SERVERNAME

-- Associate the job with a server
EXEC sp_add_jobserver @job_name='CLCleanUpJob', @server_name=@@SERVERNAME

-- Schedule to call job every 30 minutes
EXEC sp_add_jobschedule @name='CLCleanUp'
    ,@job_name='CLCleanUpJob'
    ,@freq_type=4		-- run daily
    ,@freq_interval=1		-- run every day (as opposed to every 2 days, etc.)
    ,@freq_subday_type=4	-- indicates that the sub-day frequency is expressed in minutes (4=minutes, 8=hours)
    ,@freq_subday_interval=30	-- the number of "subday_type" periods (minutes or hours) between each execution
GO

----------------------------------------------------------------
-- Create job to run CL_Scheduled_SPCalls
-- performs BULK delete

IF EXISTS (SELECT * FROM sysjobs WHERE name = 'CLScheduled_SPCallsJob')
  EXEC sp_delete_job @job_name='CLScheduled_SPCallsJob'

EXEC sp_add_job @job_name='CLScheduled_SPCallsJob',
		@category_name='Distributed Resource Monitoring',
		@enabled=1

-- Create a single step within the job
EXEC sp_add_jobstep @job_name='CLScheduled_SPCallsJob',
                    @step_name='CLScheduled_SPCallsJobStep',
                    @command='cl_processSPCalls',
		    @output_file_name='[SQLDIR]\Log\CLScheduled_SPCalls.log',
                    @database_name='Object',@server=@@SERVERNAME

-- Associate the job with a server
EXEC sp_add_jobserver @job_name='CLScheduled_SPCallsJob', @server_name=@@SERVERNAME

-- Schedule to call job every 5 minutes
EXEC sp_add_jobschedule @name='CLScheduled_SPCalls'
    ,@job_name='CLScheduled_SPCallsJob'
    ,@freq_type=4		-- run daily
    ,@freq_interval=1		-- run every day (as opposed to every 2 days, etc.)
    ,@freq_subday_type=4	-- indicates that the sub-day frequency is expressed in minutes (4=minutes, 8=hours)
    ,@freq_subday_interval=5	-- the number of "subday_type" periods (minutes or hours) between each execution

GO
----------------------------------------------------------------
-- Create job to run CL_ProcessLinkRules

-- Deleting an old job
IF EXISTS (SELECT * FROM sysjobs WHERE name = 'CL_ProcessLinkRulesJob')
  EXEC sp_delete_job @job_name='CL_ProcessLinkRulesJob'

IF EXISTS (SELECT * FROM sysjobs WHERE name = 'CL_ProcessRulesJob')
  EXEC sp_delete_job @job_name='CL_ProcessRulesJob'

EXEC sp_add_job @job_name='CL_ProcessRulesJob',
		@category_name='Distributed Resource Monitoring',
		@enabled=1

-- Create a single step within the job
EXEC sp_add_jobstep @job_name='CL_ProcessRulesJob',
                    @step_name='CL_ProcessLinkRulesJobStep',
                    @command='cl_processLinkRules',
		    @output_file_name='[SQLDIR]\Log\CL_ProcessLinkRules.log',
		    @on_success_action=3,
		    @on_fail_action=3,
                    @database_name='Object',@server=@@SERVERNAME

EXEC sp_add_jobstep @job_name='CL_ProcessRulesJob',
                    @step_name='CL_ProcessLOBRulesJobStep',
                    @command='gemsp_updateLOBviews',
		    @output_file_name='[SQLDIR]\Log\CL_ProcessLOBRules.log',
                    @database_name='Object',@server=@@SERVERNAME

-- Associate the job with a server
EXEC sp_add_jobserver @job_name='CL_ProcessRulesJob', @server_name=@@SERVERNAME

-- Schedule to call job every 3 minutes
EXEC sp_add_jobschedule @name='CL_ProcessRules'
    ,@job_name='CL_ProcessRulesJob'
    ,@freq_type=4		-- run daily
    ,@freq_interval=1		-- run every day (as opposed to every 2 days, etc.)
    ,@freq_subday_type=4	-- indicates that the sub-day frequency is expressed in minutes (4=minutes, 8=hours)
    ,@freq_subday_interval=3	-- the number of "subday_type" periods (minutes or hours) between each execution

GO

USE Object
GO


/*** Created by Randy Brown ***/
----------------------------------------------------------------

if exists (select * from sysobjects where id = object_id(N'[dbo].[CL_CIDLinks]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CL_CIDLinks]
GO

CREATE TABLE [dbo].[CL_CIDLinks] (
	[cid] [ClassID] NOT NULL ,
	[name] [nvarchar] (128) NOT NULL ,
	[direction] [tinyint] NOT NULL CONSTRAINT [DF_CL_CIDLinks_direction] DEFAULT (0),
	[discover_task] [nvarchar] (50) NULL
) ON [PRIMARY]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[CL_LOBLinks]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CL_LOBLinks]
GO

CREATE TABLE [dbo].[CL_LOBLinks] (
	[lobkey] [nvarchar] (225) NOT NULL ,
	[name] [nvarchar] (128) NOT NULL ,
	[direction] [tinyint] NOT NULL CONSTRAINT [DF_CL_LOBLinks_direction] DEFAULT (0)
) ON [PRIMARY]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[CL_LinkRules]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CL_LinkRules]
GO

CREATE TABLE [dbo].[CL_LinkRules] (
	[name] [nvarchar] (128) NOT NULL ,
	[src_direction] [tinyint] NOT NULL CONSTRAINT [DF_CL_LinkRules_direction] DEFAULT (0),
	[src_cid] [ClassID] NOT NULL ,
	[src_id] [ObjID] NOT NULL ,
	[dst_direction] [tinyint] NOT NULL CONSTRAINT [DF_CL_LinkRules_dst_direction] DEFAULT (0),
	[dst_cid] [ClassID] NULL ,
	[key_name] [nvarchar] (32) NOT NULL ,
	[condition] [nvarchar] (512) NOT NULL ,
	[enabled] [bit] NOT NULL ,
	[exclusive] [bit] NOT NULL ,
	[priority] [int] NULL ,
	[rule_id] [int] IDENTITY (1, 1) NOT NULL
) ON [PRIMARY]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[CL_LinkRulesToLinks]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CL_LinkRulesToLinks]
GO

CREATE TABLE [dbo].[CL_LinkRulesToLinks] (
	[rule_id] [int] NOT NULL ,
	[link_id] [int] NOT NULL
) ON [PRIMARY]
GO

 CREATE  INDEX [IX_CL_LinkRulesToLinks_rule_id] ON [dbo].[CL_LinkRulesToLinks]([rule_id]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_CL_LinkRulesToLinks_link_id] ON [dbo].[CL_LinkRulesToLinks]([link_id]) ON [PRIMARY]
GO

PRINT 'CL_TableDefs Completed ...'
