-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/DEFECT_79375.sqv   1.0   Jul 23 2001 17:20:50   BRENT  $
--
-- DEFECT_79375.sql
--
-- Module Description
--   Disables the scheduled task that deletes old auto-discovered jobs.
--   This is a partial fix for defect 79375 since it prevents further
--   orphaned child events on the schedules, which happens because the
--   query that the task run just marks the jobs as deleted, and does
--   not negate their child events.

USE msdb
GO


DECLARE @job_name NVARCHAR(100)
SET @job_name = N'Delete old auto-discovered batch jobs'
IF EXISTS (SELECT * FROM msdb..sysjobs WHERE name = @job_name AND enabled = 1)
BEGIN
  PRINT 'Disabling job [' + @job_name + ']'
  EXEC msdb..sp_update_job @job_name=@job_name, @enabled=0
END
