-- $Header:   //ARCHIVE/Archive_NLS/DB/sql/MasterFormatType.sqv   1.2.1.4   Jul 20 2001 11:41:36   BRENT  $
--
-- MasterFormatType.sql
--
-- Authoritative file for defining FORMAT_TYPE values.
--
-- Whenever a new FORMAT_TYPE value is defined, there should be a separate
-- file which defines the FORMAT_TYPE plus any ACTION_TYPE AND DATA_TYPE
-- values required. The definition of the FORMAT_TYPE must also be added
-- to this file so that we can control allocation of these numbers.
--
-- This file should be run any time a database is upgraded in order to make
-- sure that there are no conflicting FORMAT_TYPEs defined.

USE Object
GO
  
EXEC asisp_defineFormatType 1, 'IDENTIFICATION',          'Used to identify the Object Pump caller; other object servers'
EXEC asisp_defineFormatType 2, 'FUNCTIONAL_COMMAND',      'Used to set up SQL action; auto discovery; rediscovery; request to monitor objects; etc.'
EXEC asisp_defineFormatType 3, 'RESPONSE',                'Used to send/receive message from SQL, VTAM, etc.'
EXEC asisp_defineFormatType 4, 'ADMINISTRATIVE_COMMAND',  'Used to indicate takeover; shutdown; debug=ON/OFF; log switching; etc.'
EXEC asisp_defineFormatType 5, 'RODM',                    'Events for RODM Managed Objects'
EXEC asisp_defineFormatType 7, 'SA390',                   'Events from Systems Automation/390'
EXEC asisp_defineFormatType 8, 'OPC',                     'Events from Operations Planning and Control'
EXEC asisp_defineFormatType 9, 'OPSMVS',                  'Events from OPS/MVS'
EXEC asisp_defineFormatType 10,'AFOPERATOR',              'Events from AF/OPERATOR'
EXEC asisp_defineFormatType 11,'CA7',                     'Events from CA7'
EXEC asisp_defineFormatType 12,'AUTOOPERATOR',            'Events from Mainview AutoOperator'
EXEC asisp_defineFormatType 17,'DB2_TOWER',               'Events from DB2 Tower'
EXEC asisp_defineFormatType 18,'IMS_TOWER',               'Events from IMS Tower'
EXEC asisp_defineFormatType 19,'CICS_TOWER',              'Events from CICS Tower'
EXEC asisp_defineFormatType 21,'OS390_TOWER',             'OS/390 Tower Events'
EXEC asisp_defineFormatType 22,'SMS',                     'Events for SMS Objects'
EXEC asisp_defineFormatType 23,'HTTP',                    'Events from HTTP Servers'
