-- This script contains sample insert statements for the SystemConfiguration table which 
-- provides configuration option values for TBSM.

-- *** START OF PROBLEM/CHANGE SYSTEM INTEGRATION SECTION ***
-- Sample insert statements for enabling Problem System Integration.
--
-- Note: Problem/Change system integration must be enabled in the database server's registry for TSD
--       distributed. Problem/Change OpenAPI Release Notes V1.5 document for more details.
--
-- ^^^ TSD390 Request Processor Enablement ^^^
--
--Insert Into SystemConfiguration Values("REQUEST_PROBLEM","REQUEST_PROCESSOR_NAME","TSD390Rpin.rex","CHAR")
--Insert Into SystemConfiguration Values("REQUEST_PROBLEM","REQUEST_PROCESSOR_LANGUAGE","REXX.exe","CHAR")
--Insert Into SystemConfiguration Values("REQUEST_CHANGE","REQUEST_PROCESSOR_NAME","TSD390Rpin.rex","CHAR")
--Insert Into SystemConfiguration Values("REQUEST_CHANGE","REQUEST_PROCESSOR_LANGUAGE","REXX.exe","CHAR")
-- 
-- ^^^ TSD Distributed Request Processor Enablement ^^^
--
--Insert Into SystemConfiguration Values("REQUEST_PROBLEM","REQUEST_PROCESSOR_NAME","TSDAPIRequestProcessor.exe","CHAR")
--Insert Into SystemConfiguration Values("REQUEST_CHANGE","REQUEST_PROCESSOR_NAME","TSDAPIRequestProcessor.exe","CHAR")
-- 
-- *** END OF PROBLEM/CHANGE SYSTEM INTEGRATION SECTION ***

--*** START OF PROBLEM SYSTEM CONFIGURATION OPTIONS SECTION ***
-- Sample insert statements for configuring Problem System options.
--
-- The following section can be used to control default work flow when a problem/change system is integrated.
--
-- AUTO_SELECT_TICKET = "YES" Use this option to enable automatic selection of a problem ticket when 
--                      View,Problem Tickets is selected from the TBSM object tree menu. The value in 
--						the "propertyvalue" column is used to select a ticket with Staus = to the value entered.
--						In the example below, the first ticket with a status of "OPEN" will
--                      be selected if one exists. For NLS enter the correct language translation value for the status.
-- Insert Into SystemConfiguration Values("API_INTEGRATION_OPTIONS","AUTO_SELECT_TICKET","YES","CHAR")

-- AUTO_CLOSE_DEFAULT = "YES" will automatically attemp to close a problem ticket when the Ownership Note the
--                       ticket is linked to is closed.
--                      "NO" there will be no attempt to close the linked ticket when the Ownership Note is closed.
--
-- TICKET_CREATE_DEFAULT = "YES" will display Problem Ticket Entry dialog after entering a "Ownership" Note.
--                         "NO" will not display the dialog box.
--Insert Into SystemConfiguration Values("API_INTEGRATION_OPTIONS","AUTO_CLOSE_DEFAULT","YES","CHAR")
--Insert Into SystemConfiguration Values("API_INTEGRATION_OPTIONS","TICKET_CREATE_DEFAULT","YES","CHAR")
--
-- ^^^ FOR TSD DISTRIBUTED ONLY ^^^
-- REMEMBER_PASSWORD_DEFAULT = "YES" will remember a users TSD password and used it for future Problem Ticket 
--                             creation and maintenance.
--                           = "NO" the password will not be remembered and it will have to be entered each time a 
--                             ticket is created or maintained.
--Insert Into SystemConfiguration Values("API_INTEGRATION_OPTIONS","REMEMBER_PASSWORD_DEFAULT","YES","CHAR")
--
-- PROBLEM_SYSTEM_GUI_VALUES = "AUTO_CREATE" automatically assign a value for a SCIM part. If no row is found within this
--                             SystemConfiguration group for a SCIM part, an attempt to find that part will be made by 
--							   looking in the TSD_SCIM table for a value based on the object's CID and ID. If none is found 
--							   an empty value will be used.
--
-- The values used for AUTO_CREATE are:
--         System    = "TBSM
--         Component = Object's CID
--         Item      = Object's ID
--         Module    = Object's Name
-- 
--Insert Into SystemConfiguration Values("API_INTEGRATION_OPTIONS","ORIGIN_SYSTEM","AUTO_CREATE","CHAR")
--Insert Into SystemConfiguration Values("API_INTEGRATION_OPTIONS","ORIGIN_COMPONENT","AUTO_CREATE","CHAR")
--Insert Into SystemConfiguration Values("API_INTEGRATION_OPTIONS","ORIGIN_ITEM","AUTO_CREATE","CHAR")
--Insert Into SystemConfiguration Values("API_INTEGRATION_OPTIONS","ORIGIN_MODULE","AUTO_CREATE","CHAR")
--
-- DEBUG_MODE - Use this value to control the deletion of <GUID>.in and <GUID>.out files from the 
--              TBSM Database Server's data folder. A value of 'OFF' will delete these files and 
--              a value of 'ON' will leave the file in the folder. The default behaviour is 'ON'.
--
-- TIMEOUT_VALUE - The time is seconds that the IntegrationManager object will wait for a request
--                 processor to return from a request call. The default is 45 seconds. A value of 0 
--                 or a non-numeric value will default to 45 seconds. There is currently no maximum value
--                 but don't set this value too high as it may cause unwanted delays.
--
-- Insert Into SystemConfiguration Values('API_INTEGRATION_OPTIONS','DEBUG_MODE','ON','CHAR')                
-- Insert Into SystemConfiguration Values('API_INTEGRATION_OPTIONS','TIMEOUT_VALUE','45','INTEGER')             
-- 
--*** END OF API_INTEGRATION_OPTIONS SECTION ***
--
--
--*** START OF Note Viewer configuration options. ***
-- Sample insert statements for providing default values Aging criteria.
--
-- Defaulr Colors are:
--         Critical = Red
--         High = Yellow
--         Medium = Light Blue
--         Low = White
--
-- The propertyvalue must be the long RGB color number of the color to use.
--
--Insert Into SystemConfiguration Values( "AGING_CRITERIA_DEFAULT", "CRITICAL_VALUE","640","LONG")
--Insert Into SystemConfiguration Values( "AGING_CRITERIA_DEFAULT", "CRITICAL_COLOR","255","LONG")
--Insert Into SystemConfiguration Values( "AGING_CRITERIA_DEFAULT", "HIGH_VALUE","360","LONG")
--Insert Into SystemConfiguration Values( "AGING_CRITERIA_DEFAULT", "HIGH_COLOR","65535","LONG")
--Insert Into SystemConfiguration Values( "AGING_CRITERIA_DEFAULT", "MEDIUM_VALUE","180","LONG")
--Insert Into SystemConfiguration Values( "AGING_CRITERIA_DEFAULT", "MEDIUM_COLOR","16776960","LONG")
--Insert Into SystemConfiguration Values( "AGING_CRITERIA_DEFAULT", "LOW_VALUE","1","LONG"
--Insert Into SystemConfiguration Values( "AGING_CRITERIA_DEFAULT", "LOW_COLOR","-2147483643","LONG")
--
--*** END OF Note Viewer configuration options. ***

