-- $Header:   //ARCHIVE/Archive_NLS/DB/sql/alloc_BATC.sqv   1.0   Jul 17 2001 14:02:04   BRENT  $
--
-- alloc_BATC.sql
--
-- Module Description
--   Defines the alloc_BATC stored procedure

USE Object
GO


---------------------------------------------------------------------------------------------------
-- alloc_BATC
PRINT 'Creating procedure alloc_BATC'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'alloc_BATC' AND type = 'P')
  DROP PROCEDURE alloc_BATC
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/sql/alloc_BATC.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jul 17 2001 14:02:04  $
-- $Author:   BRENT  $
-- Custom version of alloc_BATC that allocates in one step rather than a loop
CREATE PROCEDURE alloc_BATC
  @count    int=1
AS
  IF @count = 0
    RETURN

  DECLARE @tcount INT
  SET @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRANSACTION alloc_BATC
  ELSE
    SAVE TRANSACTION alloc_BATC

  DECLARE @last_id INT
  SELECT @last_id = last_id+1 FROM BATC_ID
  UPDATE BATC_ID SET last_id = last_id + @count

  IF @tcount = 0  
    COMMIT TRANSACTION alloc_BATC

  RETURN @last_id
GO
