-- $Header

-- alloc_FILE.sql

-- Resolve defect #78965
-- Remove while loop when @count > 1

USE Object
GO

---------------------------------------------------------------------------------------------------------------
-- alloc_FILE
PRINT 'Creating alloc_FILE procedure....'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE name = 'alloc_FILE' AND type = 'P')
  DROP PROCEDURE alloc_FILE
GO 

-- $Archive:   //ARCHIVE/Archive_NLS/DB/sql/alloc_FILE.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jul 16 2001 16:23:56  $
-- $Author:   Xiaoyan  $
-- modified for better performance on bulk creation
CREATE PROCEDURE alloc_FILE
  @count    INT=1
AS
  BEGIN TRAN alloc_FILE

  IF @count > 0
    UPDATE FILE_ID SET last_id=last_id+@count
  DECLARE @last_id INT
  SELECT @last_id=last_id FROM FILE_ID

  COMMIT TRAN alloc_FILE
  RETURN @last_id

GO
