-- $Header

-- alloc_TRAN.sql

-- Resolve defect #78965
-- Remove while loop when @count > 1

USE Object
GO

---------------------------------------------------------------------------------------------------------------
-- alloc_TRAN
PRINT 'Creating alloc_TRAN procedure....'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE name = 'alloc_TRAN' AND type = 'P')
  DROP PROCEDURE alloc_TRAN
GO 

-- $Archive:   //ARCHIVE/Archive_NLS/DB/sql/alloc_TRAN.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jul 16 2001 16:24:06  $
-- $Author:   Xiaoyan  $
-- modified for better performance on bulk creation
CREATE PROCEDURE alloc_TRAN
  @count    INT=1
AS
  BEGIN TRAN alloc_TRAN

  IF @count > 0
    UPDATE TRAN_ID SET last_id=last_id+@count

  DECLARE @last_id INT
  SELECT @last_id=last_id FROM TRAN_ID

  COMMIT TRAN alloc_TRAN

  RETURN @last_id

GO
