-- $Header$
--
-- asisp_DB2updatePaths
--
-- Module Description
--   Defines the asisp_DB2updatePaths stored PROCEDURE

USE Object
GO

--------------------------------------------------------------------------------------------------
-- asisp_DB2updatePaths
PRINT 'Creating PROCEDURE asisp_DB2updatePaths'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'asisp_DB2updatePaths' AND type = 'P')
  DROP PROCEDURE asisp_DB2updatePaths
GO

-- $Archive:   //Rulestest/Archive/DB/sql/asisp_DB2updatePaths.sqv  $
-- $Revision:   1.0  $
-- $Date:   May 01 2001 20:43:28  $
-- $Author:   Forthman  $
CREATE PROCEDURE asisp_DB2updatePaths
AS
  RAISERROR('asisp_DB2updatePaths: ', 0, 1)

  -- Standard TRANSACTION logic
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN asisp_DB2updatePaths
  ELSE
    SAVE TRAN asisp_DB2updatePaths

  -- Walk through all the objects that are member to the DB2Base_C TABLE ('D2BA') AND UPDATE their _Path
  SET NOCOUNT ON

  DECLARE @cname NVARCHAR(24)
  DECLARE @sql NVARCHAR(500)
  DECLARE @path NVARCHAR(500)


  DECLARE @count INT
  SELECT @count = 0
  DECLARE ic CURSOR FOR
    SELECT i.cid, i.id
    FROM DB2Base_C AS i
      WHERE deleted = 0
        AND _Path IS NULL
  OPEN ic
  DECLARE @cid ClassID, @id ObjID
  FETCH NEXT FROM ic INTO @cid, @id
  WHILE @@FETCH_STATUS <> -1
  BEGIN
    SELECT @cid, @id

    EXEC asisp_fullpath @cid, @id, @path OUTPUT

    SELECT @cname = cname FROM obj_class WHERE cid = @cid
    SELECT @sql = "
    UPDATE " + @cname + "_C
      SET _Path = '" + @path + "'
      WHERE cid = '" + @cid + "'
        AND id = " + CONVERT( NVARCHAR(8), @id) + "
    "
    EXEC (@sql)

    IF @@ERROR <> 0 
    BEGIN
      RAISERROR( 'asisp_updatePath: Error attempting to UPDATE _Path WHERE @cid=%s, @id=%d, @@ERROR=%d', 11, 1, @cid, @id, @@ERROR)
      ROLLBACK TRANSACTION asisp_DB2updatePaths
      RETURN -30000
    END

    SELECT @count = @count + 1
    FETCH NEXT FROM ic INTO @cid, @id
  END
  DEALLOCATE ic
  RAISERROR( 'Number of records updated: %d', 0, 1, @count)
  
  -- Standard TRANSACTION logic
  IF @tcount = 0
    COMMIT TRAN asisp_DB2updatePaths
GO

