-- $Header:   //ARCHIVE/PVCSROOT/Archive_NLS/Db/Sql/asisp_FillInMonitoredStagingTable.sqv   1.0   Jul 23 2001 16:29:34   Forthman  $
-- asisp_FillInMonitoredStagingTable.sql
-- 
-- Module Definition
--   Defines the asisp_FillInMonitoredStagingTable stored procedure

Use Object
GO
------------------------------------------------------------------------------------
-- asisp_FillInMonitoredStagingTable
PRINT 'Create procedure asisp_FillInMonitoredStagingTable'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'asisp_FillInMonitoredStagingTable' AND type = 'P' )
  DROP PROCEDURE asisp_FillInMonitoredStagingTable
GO

-- $Archive:   //ARCHIVE/PVCSROOT/Archive_NLS/Db/Sql/asisp_FillInMonitoredStagingTable.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jul 23 2001 16:29:34  $
-- $Author:   Forthman  $
-- This procedure allows you to prepopulate the MonitoredStagingTable with data.
CREATE PROCEDURE asisp_FillInMonitoredStagingTable
AS
  DECLARE @name sysname
  DECLARE @rows_yellow INT
  DECLARE @rows_red INT
  DECLARE @idle_yellow INT
  DECLARE @idle_red INT
  DECLARE @sample_rows INT
  DECLARE @sample_time DATETIME
  DECLARE @sample_timestamp BINARY(8)
  DECLARE @idle_time DATETIME
  DECLARE @idle_alert INT
  DECLARE @rows_alert INT
  DECLARE @rowcount INT

  DECLARE tc INSENSITIVE CURSOR FOR
    SELECT name, numrows_yellow, numrows_red, oldest_yellow, oldest_red
    FROM PendingEventTableDef
  OPEN tc
  FETCH NEXT FROM tc INTO @name, @rows_yellow, @rows_red, @idle_yellow, @idle_red

  WHILE @@FETCH_STATUS <> -1
  BEGIN

    SELECT @rowcount = COUNT(*)
      FROM MonitoredStagingTable
      WHERE name=@name

    IF @rowcount=0
    BEGIN
      IF @name<>"StagedBucketNotification"
      BEGIN
        INSERT INTO MonitoredStagingTable (name, description, rows_yellow, rows_red, idle_yellow, idle_red, sample_rows, sample_time, sample_timestamp, idle_time, idle_alert, rows_alert)
          VALUES (@name, " ", @rows_yellow, @rows_red, @idle_yellow, @idle_red, 0, GETDATE(), NULL, NULL, 1, 1)
      END
    END
    FETCH NEXT FROM tc INTO @name, @rows_yellow, @rows_red, @idle_yellow, @idle_red
  END
  DEALLOCATE tc
GO
