-- $Header:   //Archive/Pvcsroot/Archive_NLS/Db/Sql/asisp_IMSUpdatePaths.sqv   1.0   Jul 24 2001 16:14:00   Forthman  $
--
-- asisp_IMSUpdatePaths
--
-- Module Description
--   Defines the asisp_IMSUpdatePaths stored PROCEDURE

USE Object
GO

--------------------------------------------------------------------------------------------------
-- asisp_fullpath
PRINT 'Creating PROCEDURE asisp_IMSUpdatePaths'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'asisp_IMSUpdatePaths' AND type = 'P')
  DROP PROCEDURE asisp_IMSUpdatePaths
GO

-- $Archive:   //Archive/Pvcsroot/Archive_NLS/Db/Sql/asisp_IMSUpdatePaths.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jul 24 2001 16:14:00  $
-- $Author:   Forthman  $
CREATE PROCEDURE asisp_IMSUpdatePaths
AS
  RAISERROR('asisp_IMSUpdatePaths: ', 0, 1)

  -- Standard TRANSACTION logic
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN asisp_IMSUpdatePaths
  ELSE
    SAVE TRAN asisp_IMSUpdatePaths

  -- Walk through all the objects that are member to the IMSBase_C TABLE ('IMBA') AND UPDATE their _Path
  SET NOCOUNT ON

  DECLARE @count INT
  SELECT @count = 0
  DECLARE ic CURSOR FOR
    SELECT i.cid, i.id
    FROM IMSBase_C AS i
      WHERE deleted = 0
--    WHERE i._Path IS NULL
  OPEN ic
  DECLARE @cid ClassID, @id ObjID
  FETCH NEXT FROM ic INTO @cid, @id
  WHILE @@FETCH_STATUS <> -1
  BEGIN
    EXEC asisp_IMSUpdatePath @cid, @id
    SELECT @count = @count + 1
    FETCH NEXT FROM ic INTO @cid, @id
  END
  DEALLOCATE ic
  RAISERROR( 'Number of records updated: %d', 0, 1, @count)
  


  -- Standard TRANSACTION logic
  IF @tcount = 0
    COMMIT TRAN asisp_IMSUpdatePaths
GO

