-- $Header:   //Archive/Pvcsroot/Archive_NLS/Db/Sql/asisp_fullpath.sqv   1.0   Jul 24 2001 16:13:40   Forthman  $
--
-- asisp_fullpath
--
-- Module Description
--   Defines the asisp_fullpath stored PROCEDURE

USE Object
GO

--------------------------------------------------------------------------------------------------
-- asisp_fullpath
PRINT 'Creating PROCEDURE asisp_fullpath'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'asisp_fullpath' AND type = 'P')
  DROP PROCEDURE asisp_fullpath
GO

-- $Archive:   //Archive/Pvcsroot/Archive_NLS/Db/Sql/asisp_fullpath.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jul 24 2001 16:13:40  $
-- $Author:   Forthman  $
CREATE PROCEDURE asisp_fullpath
  @cid ClassID,
  @id  ObjID,
  @path NVARCHAR(255) output
AS
  DECLARE @sql NVARCHAR(255), @name ObjName, @parent_cid ClassID, @parent_id ObjID
  SELECT @path = NULL
  WHILE @cid <> 'BUSC' AND @cid <> 'LOBC'
  BEGIN
    SELECT @sql = 'DECLARE asisp_fullpath_c CURSOR FOR SELECT name' +
      CASE WHEN flag_direct_containment = 1 THEN ', _ParentCID, _ParentID' ELSE ', NULL, NULL' END +
      ' FROM ' + cname + '_V WHERE id=' + CONVERT(NVARCHAR(9), @id)
      FROM obj_class WHERE cid = @cid
    EXEC(@sql)
    OPEN asisp_fullpath_c
    FETCH NEXT FROM asisp_fullpath_c INTO @name, @parent_cid, @parent_id
    DEALLOCATE asisp_fullpath_c 

    IF @path IS NULL
      SELECT @path = @name
    ELSE
      SELECT @path = @name + '/' + @path

    IF @parent_cid IS NULL
      SELECT @cid = src_cid, @id = src_id FROM containment WHERE dst_cid = @cid AND dst_id = @id
    ELSE
      SELECT @cid = @parent_cid, @id = @parent_id
    IF @@ROWCOUNT <> 1
      BREAK
  END
GO

