-- $Header:   //ARCHIVE/PVCSROOT/Archive_NLS/Db/Sql/asisp_testsqlresponsetimes.sqv   1.0   Jul 23 2001 16:32:24   Forthman  $
-- asisp_testsqlresponsetimes.sql
-- 
-- Module Definition
--   Defines the asisp_testsqlresponsetimes stored procedure

Use Object
GO
------------------------------------------------------------------------------------
-- asisp_testsqlresponsetimes
PRINT 'Create procedure asisp_testsqlresponsetimes'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'asisp_testsqlresponsetimes' AND type = 'P' )
  DROP PROCEDURE asisp_testsqlresponsetimes
GO

-- $Archive:   //ARCHIVE/PVCSROOT/Archive_NLS/Db/Sql/asisp_testsqlresponsetimes.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jul 23 2001 16:32:24  $
-- $Author:   Forthman  $
-- This procedure allows the user to test the sql response times.  It is normally run
--  with setting exec to 0.  This procedure is run by the job 'Refresh SQL Response Time Tests'
CREATE PROCEDURE asisp_testsqlresponsetimes
  @exec   TINYINT = 1, -- SET to 0 to simply SELECT the results of the last execution
  @delim  NCHAR(1) = NULL
AS
  IF @exec = 1
  BEGIN
    DELETE asi_sqlresponsetimetest
    EXEC sp_testsqlresponsetime 'CICSStatusSummary', '_CICSStatusSummary "ENT", 1', 10,15
    EXEC sp_testsqlresponsetime 'LOB_CICSStatusSummary', 'EXEC LOB_CICSStatusSummary "LOB", 4875', 5, 10
    EXEC sp_testsqlresponsetime 'GetBatchCycleSets', 'EXEC _GetBatchCycleSets "ENT", 1', 5, 10
    EXEC sp_testsqlresponsetime 'GetBatchCycles', 'EXEC _GetBatchCycles "BCYS", 1', 5, 10
    EXEC sp_testsqlresponsetime 'FindFiles', 'EXEC _FindFiles @cid="ENT", @id=1,@where="(((_Open<>""OPE"" OR _Enabled<>""ENA"") AND _PriorityID>=1 AND _PriorityID<=4) AND _DISCOVERY_IND=""MON"")"', 15, 20
    EXEC sp_testsqlresponsetime 'GetExceptions', 'EXEC _GetExceptions @cid="OS", @id=30', 5, 10
    EXEC sp_testsqlresponsetime 'GetMessages', 'EXEC _GetMessages @cid="CICS", @id=633', 5, 10
    EXEC sp_testsqlresponsetime 'GetBatchCycleJobs', 'EXEC _GetBatchCycleJobs @cid="BTCY", @id=57,@schedStatusMask=2,@jobTypeMask=2', 5, 10
    EXEC sp_testsqlresponsetime 'GetBatchCycleJobHist - Job', 'EXEC _GetBatchCycleJobHist @cid="BATC", @id=1818,@keyJobIDExpr="=1818"', 5, 10
    EXEC sp_testsqlresponsetime 'GetBatchCycleJobHist - Schedule', 'EXEC _GetBatchCycleJobHist @cid="BTCY", @id=57', 15, 20
    EXEC sp_testsqlresponsetime 'GetChildList', 'EXEC asisp_getchildlist @cid="OS", @id=5', 5, 10
  END
  IF @delim IS NULL
    SELECT 
      name,
      alert_state = CASE alert WHEN 1 THEN 'GREEN' WHEN 2 THEN 'YELLOW' ELSE 'RED' END,
      elapsed_sec = CONVERT(FLOAT, elapsed_msec) / 1000,
      rc,
      starttime = CONVERT(NVARCHAR(40), starttime, 113),
      endtime = CONVERT(NVARCHAR(40), endtime, 113),
      sql
    FROM
      asi_sqlresponsetimetest
    ORDER BY
      alert desc,
      elapsed_msec desc
  ELSE
  BEGIN
    CREATE TABLE #output (line NVARCHAR(255))
    INSERT #output
      SELECT '#Name'  + @delim + 'Sec'  + @delim + 'SCOLOR' + @delim + 'Rows' + @delim + 'Start Time' + @delim + 'END Time' + @delim + 'Query'
    INSERT #output
      SELECT '#-30s ' + @delim + '6.1f' + @delim + '-8s '   + @delim + '6d '  + @delim + '-18s '      + @delim + '-18s '    + @delim + '-s'
    INSERT #output
     SELECT 
      name + @delim +
      CONVERT(NVARCHAR(8), CONVERT(FLOAT, elapsed_msec) / 1000) + @delim +
      CASE alert WHEN 1 THEN 'GREEN' WHEN 2 THEN 'YELLOW' ELSE 'RED' END + @delim +
      CONVERT(NVARCHAR(9), rc) + @delim +
      CONVERT(NVARCHAR(40), starttime, 111) + ' ' + CONVERT(NVARCHAR(40), starttime, 108) + @delim +
      CONVERT(NVARCHAR(40), endtime, 111) + ' ' + CONVERT(NVARCHAR(40), endtime, 108) + @delim +
      sql
    FROM
      asi_sqlresponsetimetest
    ORDER BY
      alert desc,
      elapsed_msec desc
    SELECT * FROM #output
  END
GO
