-- $Header:   //ARCHIVE/Archive_NLS/DB/SQL/asisp_uploadGetOmegRes.sqv   1.5   Jul 24 2001 13:56:38   BRENT  $
--
-- asisp_uploadGetOmegRes.sql
--
-- Module Description:
--   Defines the asisp_uploadGetOmegRes stored procedure

USE Object
GO


---------------------------------------------------------------------------------------------------
-- asisp_uploadGetOmegRes
PRINT 'Creating procedure asisp_uploadGetOmegRes'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE name = 'asisp_uploadGetOmegRes' AND type = 'P')
  DROP PROCEDURE asisp_uploadGetOmegRes
GO

-- $Archive:   //ARCHIVE/Archive_NLS/DB/SQL/asisp_uploadGetOmegRes.sqv  $
-- $Revision:   1.5  $
-- $Date:   Jul 24 2001 13:56:38  $
-- $Author:   BRENT  $
CREATE PROCEDURE asisp_uploadGetOmegRes
  @cid	ClassID,
  @id	ObjID,
  @formatted TINYINT=0,
  @bConnectAllOSDescendents TINYINT=0,
  @bMarkConnectedStatus TINYINT=null
AS
  SET NOCOUNT ON

  PRINT 'asisp_uploadGetOmegRes'
   + ' @cid=' + CASE WHEN @cid IS NULL THEN 'NULL' ELSE '''' + @cid + '''' END
   + ', @id=' + CASE WHEN @id IS NULL THEN 'NULL' ELSE CAST(@id AS VARCHAR) END
   + ', @formatted=' + CASE WHEN @formatted IS NULL THEN 'NULL' ELSE CAST(@formatted AS VARCHAR) END
   + ', @bConnectAllOSDescendents=' + CASE WHEN @bConnectAllOSDescendents IS NULL THEN 'NULL' ELSE CAST(@bConnectAllOSDescendents AS VARCHAR) END
   + ', @bMarkConnectedStatus=' + CASE WHEN @bMarkConnectedStatus IS NULL THEN 'NULL' ELSE CAST(@bMarkConnectedStatus AS VARCHAR) END

  DECLARE @sql NVARCHAR(2000)
  DECLARE @cmd NVARCHAR(255)
  DECLARE @omeg_type INT
  DECLARE @active INT
  DECLARE @omeg_active INT
  DECLARE @status NVARCHAR(255)
  DECLARE @stat   INT
  DECLARE @obj_cid ClassID
  DECLARE @obj_id  ObjID

  SELECT @omeg_active=id FROM StateType_C WHERE name like 'OMEG_Active'

  -- Standard transaction logic
  DECLARE @tcount INT
  SELECT @tcount = @@trancount
  IF @tcount = 0
    BEGIN TRANSACTION asisp_uploadGetOmegRes
  ELSE
    save TRANSACTION asisp_uploadGetOmegRes

  CREATE TABLE #uploadGetOmegRes
  (
    cid               ClassID,
    id                ObjID,
    name              ObjName      NULL DEFAULT NULL,
    _UploadUserID     NVARCHAR(16)  NULL DEFAULT NULL,
    _UploadPassword   NVARCHAR(16)  NULL DEFAULT NULL,
    svc_host          NVARCHAR(30)  NULL,
    svc_name          NVARCHAR(30)  NULL
  )

  -- special handling for OMGR (OmegamonManagedResource)
  IF @bConnectAllOSDescendents=0 AND EXISTS (SELECT * FROM isa_chain WHERE base_cid='OMGR' AND base_cid!=cid AND cid=@cid)
  BEGIN
    INSERT #uploadGetOmegRes(cid, id, name, _UploadUserID, _UploadPassword, svc_host, svc_name) EXEC asisp_uploadGetOSInfo @cid, @id

    CREATE TABLE #uploadGetOmegRes4
    (
      os_id             ObjID,
      os_name           ObjName,
      cid               ClassID,
      id                ObjID,
      cno               INT,
      name              ObjName,
      _ApplID           NVARCHAR(8),
      _PerfMonProduct   INT,
      _OmegamonUserID   NVARCHAR(8) NULL,
      _OmegamonPassword NVARCHAR(8) NULL,
      _Interval         DATETIME NULL,
      _LogicalRows      INT,
      target_os         ObjName
    )

    SELECT @omeg_type=
      CASE
        WHEN @cid = 'OS'   THEN 1
        WHEN @cid = 'CICS' THEN 2
        WHEN @cid = 'DB2'  THEN 3
        WHEN @cid LIKE 'D2%' THEN 3
        WHEN @cid LIKE 'IM%' THEN 4
        ELSE 0
      END

    IF @cid='OS' AND @bConnectAllOSDescendents=0
    BEGIN
      INSERT #uploadGetOmegRes4(os_id, os_name, cid, id, cno, name, _ApplID, _PerfMonProduct, _OmegamonUserID, _OmegamonPassword, _Interval, _LogicalRows, target_os)
        SELECT t.id, v.name, "OS", v.id, oc.cno, ISNULL(v._SMFID, v.name), _ApplID, _PerfMonProduct, NULL, NULL, _Interval, _LogicalRows, ISNULL(v._SMFID, v.name)
        FROM
          OS_V AS v
            JOIN #uploadGetOmegRes AS t ON t.id = v.id
            JOIN OmegamonLogin_A AS ol ON ol.id = v._OmegamonLoginID
            JOIN Omegamon_A AS o ON o._ApplID = ol._OmegamonApplID,
          obj_class AS oc
        WHERE
          o._PerfMonProduct=@omeg_type
          AND o._CurrentStateID=@omeg_active
          AND oc.cid='OS'
    END
    ELSE
    BEGIN
      SELECT @active=id FROM StateType_C WHERE name=RTRIM(@cid)+'_Active'
      SELECT @sql =
         'INSERT #uploadGetOmegRes4(os_id, os_name, cid, id, cno, name, _ApplID, _PerfMonProduct, _OmegamonUserID, _OmegamonPassword, _Interval, _LogicalRows, target_os)
  SELECT t.id, os.name, "'+RTRIM(@cid)+'", v.id, cno, v.name, _ApplID, _PerfMonProduct, NULL, NULL, _Interval, _LogicalRows, ISNULL(os._SMFID, os.name)
  FROM '+cname+'_V v, OmegamonLogin_A ol, #uploadGetOmegRes t, Omegamon_A o, obj_class oc, OS_V os, link l
  WHERE v._OmegamonLoginID=ol.id' FROM obj_class WHERE cid=RTRIM(@cid)
      SELECT @sql = @sql 
      + ' AND o._ApplID=ol._OmegamonApplID
          AND o._PerfMonProduct='+CONVERT(NVARCHAR(255),@omeg_type)+'
          AND o._CurrentStateID='+CONVERT(NVARCHAR(255),@omeg_active)+'
          AND oc.cid="'+RTRIM(@cid)+'"
          AND src_cid="OS"
          AND src_id=os.id'
      + ' AND dst_cid="'+RTRIM(@cid)+'"
          AND dst_id=v.id
          AND link_type="PHYC"
          AND l.deleted=0
          AND v.id='+CONVERT(NVARCHAR(255),@id)+'
          AND v._CurrentStateID='+CONVERT(NVARCHAR(255),@active)
    END
--    PRINT @sql
    EXEC(@sql)

    -- obtain the values for the overridable attributes UploadUserID, UploadPassword
    EXEC asisp_updateOverrideAttrs #uploadGetOmegRes4, cid, id, '_OmegamonUserID', @cid, OmegamonUserID
    EXEC asisp_updateOverrideAttrs #uploadGetOmegRes4, cid, id, '_OmegamonPassword', @cid, OmegamonPassword

    IF @formatted = 1
      SELECT 'DATA_ROW|'+CONVERT(NVARCHAR(255),os_id)+'|'+os_name+'|'+RTRIM(cid)+'|'+CONVERT(NVARCHAR(255),id)+'|'+
             CONVERT(NVARCHAR(255),cno)+'|'+name+'|'+_ApplID+'|'+CONVERT(NVARCHAR(255),_PerfMonProduct)+'|'+
             _OmegamonUserID+'|'+_OmegamonPassword+'|'+CONVERT(NVARCHAR(255),_Interval,108)+'|'+CONVERT(NVARCHAR(255),_LogicalRows)+'|'+target_os
        FROM #uploadGetOmegRes4
    ELSE
      SELECT os_id, os_name, cid, id, cno, name, _ApplID, _PerfMonProduct, _OmegamonUserID, _OmegamonPassword, _Interval=CONVERT(NVARCHAR(255),_Interval,108), _LogicalRows, target_os
        FROM #uploadGetOmegRes4

    -- assert the facts into the rule engine
    EXEC @stat = asisp_declarecursor asisp_uploadGetOmegRes_c2, 'SELECT cid, id FROM #uploadGetOmegRes4', 1
    IF @stat < 0
    BEGIN
       ROLLBACK TRANSACTION asisp_uploadGetOmegRes
       RETURN -3000
    END
    OPEN asisp_uploadGetOmegRes_c2
    FETCH NEXT FROM asisp_uploadGetOmegRes_c2 INTO @obj_cid, @obj_id
    WHILE @@fetch_status <> -1
    BEGIN
      SELECT @cmd='(assert (OmegamonLogonSent (cid "'+RTRIM(@obj_cid)+'") (id '+CONVERT(NVARCHAR(255),@obj_id)+')))'
      RAISERROR('asisp_uploadGetOmegRes: %s', 0, 1, @cmd)
      EXEC sp_sendrulecmd 'MVSUpload', @cmd
      FETCH NEXT FROM asisp_uploadGetOmegRes_c2 INTO @obj_cid, @obj_id
    END
    DEALLOCATE asisp_uploadGetOmegRes_c2
    EXEC sp_sendrulecmd 'MVSUpload', '(run)'

    IF @bMarkConnectedStatus IS NOT NULL
    BEGIN
      SELECT @status=v.label FROM enumeration e, enum_value v
        WHERE e.name='OmegamonStatus'
          AND e.eid=v.eid
          AND value=@bMarkConnectedStatus
      RAISERROR('asisp_uploadGetOmegRes: marking all OMGR''s as ''%s'' associated with cid=%s id=%d', 0, 1, @status, @cid, @id)
      UPDATE OmegamonLogin_A
        SET _LastOmegamonStatus=@bMarkConnectedStatus
        FROM link l, OmegamonLogin_A a, #uploadGetOmegRes4 t
        WHERE a.id=dst_id
          AND src_cid=t.cid
          AND src_id=t.id
          AND dst_cid='OMGL' 
          AND deleted=0
    END

    DROP TABLE #uploadGetOmegRes4
    IF @tcount = 0
      COMMIT TRANSACTION asisp_uploadGetOmegRes
    RETURN
  END

  INSERT INTO #uploadGetOmegRes(cid, id, name, _UploadUserID, _UploadPassword, svc_host, svc_name)
    EXEC asisp_uploadGetOSInfo @cid, @id

  IF (SELECT COUNT(*) FROM #uploadGetOmegRes) = 0
    PRINT 'asisp_uploadGetOSInfo returned no rows'

  CREATE TABLE #uploadGetOmegRes2
  (
    cid               ClassID,
    id                ObjID,
    _ApplID           NVARCHAR(8),
    _PerfMonProduct   INT,
    _OmegamonUserID   NVARCHAR(8) NULL DEFAULT NULL,
    _OmegamonPassword NVARCHAR(8) NULL DEFAULT NULL
  )

  -- Insert all of the OMEG(s) contained within the OS's found by asisp_uploadGetOSInfo
  INSERT #uploadGetOmegRes2(cid, id, _ApplID, _PerfMonProduct)
    SELECT 'OMEG', dst_id, _ApplID, _PerfMonProduct
      FROM link l, #uploadGetOmegRes t, Omegamon_A a
      WHERE src_cid='OS'
        AND src_id=t.id
        AND dst_cid='OMEG'
        AND dst_id=a.id
        AND link_type='PHYC'
        AND deleted=0
        AND _CurrentStateID=@omeg_active
  IF @@ROWCOUNT = 0
    PRINT 'No Omegamons currently active under ' + @cid + ' ' + CAST(@id AS VARCHAR)

  IF @cid='OMEG'
    DELETE FROM #uploadGetOmegRes2 WHERE id<>@id

  -- cleanup table as not used again
  DROP TABLE #uploadGetOmegRes

  -- obtain the values for the overridable attributes UploadUserID, UploadPassword
  EXEC asisp_updateOverrideAttrs #uploadGetOmegRes2, cid, id, '_OmegamonUserID', OMEG, OmegamonUserID
  EXEC asisp_updateOverrideAttrs #uploadGetOmegRes2, cid, id, '_OmegamonPassword', OMEG, OmegamonPassword

  CREATE TABLE #uploadGetOmegRes3
  (
    os_id             ObjID,
    os_name           ObjName,
    cid               ClassID,
    id                ObjID,
    cno               INT,
    name              ObjName,
    _ApplID           NVARCHAR(8),
    _PerfMonProduct   INT,
    _OmegamonUserID   NVARCHAR(8),
    _OmegamonPassword NVARCHAR(8),
    _Interval         DATETIME NULL,
    _LogicalRows      INT,
    target_os         ObjName
  )

  -- Update attributes FROM each OMGR managed BY each OMEG in #uploadGetOmegRes2
  DECLARE @omgr_cid ClassID
  DECLARE asisp_uploadGetOmegRes_c CURSOR FOR
    SELECT ic.cid FROM isa_chain AS ic JOIN obj_class AS oc ON oc.cid = ic.cid
    WHERE ic.base_cid='OMGR' AND ic.base_cid != ic.cid AND oc.flag_abstract = 0
  OPEN asisp_uploadGetOmegRes_c
  FETCH NEXT FROM asisp_uploadGetOmegRes_c INTO @omgr_cid
  WHILE @@fetch_status <> -1
  BEGIN
    SELECT @omeg_type=
      CASE
        WHEN @omgr_cid = 'OS'   THEN 1
        WHEN @omgr_cid = 'CICS' THEN 2
        WHEN @omgr_cid = 'DB2'  THEN 3
        WHEN @omgr_cid LIKE 'D2%' THEN 3
        WHEN @omgr_cid LIKE 'IM%' THEN 4
        ELSE 0
      END

    IF @omgr_cid='OS'
    BEGIN
      INSERT #uploadGetOmegRes3(os_id, os_name, cid, id, cno, name, _ApplID, _PerfMonProduct, _OmegamonUserID, _OmegamonPassword, _Interval, _LogicalRows, target_os)
        SELECT v.id, v.name, "OS", v.id, cno, ISNULL(v._SMFID,v.name), _ApplID, _PerfMonProduct, t2._OmegamonUserID, t2._OmegamonPassword, _Interval, _LogicalRows, ISNULL(v._SMFID,v.name)
          FROM OS_V v, OmegamonLogin_A ol, #uploadGetOmegRes2 t2, obj_class oc
          WHERE v._OmegamonLoginID=ol.id
            AND ol._OmegamonApplID=t2._ApplID
            AND t2._PerfMonProduct=@omeg_type
            AND oc.cid="OS"
            AND ol._LastOmegamonUserAction=1
    END
    ELSE
    BEGIN
      SELECT @active=id FROM StateType_C WHERE name=RTRIM(@omgr_cid)+'_Active'
      SELECT @sql = "
        SELECT os.id, os.name, '"+RTRIM(@omgr_cid)+"', v.id, cno, v.name, _ApplID, _PerfMonProduct, t2._OmegamonUserID, t2._OmegamonPassword, _Interval, _LogicalRows, ISNULL(os._SMFID,os.name)
        FROM "
          +cname+"_V AS v
            JOIN OmegamonLogin_A AS ol ON v._OmegamonLoginID=ol.id
            JOIN #uploadGetOmegRes2 AS t2 ON ol._OmegamonApplID=t2._ApplID
            JOIN link AS l ON l.dst_cid='"+RTRIM(@omgr_cid)+"' AND l.dst_id=v.id AND link_type='PHYC' AND l.src_cid='OS'
            JOIN OS_V AS os ON os.id=l.src_id,
          obj_class AS oc
        WHERE
          t2._PerfMonProduct=" + CAST(@omeg_type AS VARCHAR) + "
          AND oc.cid='"+RTRIM(@omgr_cid)+"'
          AND l.deleted=0
          AND ol._LastOmegamonUserAction=1
          AND v._CurrentStateID="+CAST(@active AS VARCHAR)
      FROM obj_class
      WHERE cid=@omgr_cid
    END

/* 
--Uncomment this block for diagnostic output. Note this cannot be left in for application use
    BEGIN
      PRINT @sql
      EXEC(@sql)
    END
*/

    EXEC("
    INSERT INTO #uploadGetOmegRes3(os_id, os_name, cid, id, cno, name, _ApplID, _PerfMonProduct, _OmegamonUserID, _OmegamonPassword, _Interval, _LogicalRows, target_os)
    " + @sql
    )
    FETCH NEXT FROM asisp_uploadGetOmegRes_c INTO @omgr_cid
  END
  DEALLOCATE asisp_uploadGetOmegRes_c

  DROP TABLE #uploadGetOmegRes2

  IF @formatted = 1
    SELECT 'DATA_ROW|'+CONVERT(NVARCHAR(255),os_id)+'|'+os_name+'|'+RTRIM(cid)+'|'+CONVERT(NVARCHAR(255),id)+'|'+
           CONVERT(NVARCHAR(255),cno)+'|'+name+'|'+_ApplID+'|'+CONVERT(NVARCHAR(255),_PerfMonProduct)+'|'+_OmegamonUserID+'|'+
           _OmegamonPassword+'|'+CONVERT(NVARCHAR(255),_Interval,108)+'|'+CONVERT(NVARCHAR(255),_LogicalRows)+'|'+target_os
      FROM #uploadGetOmegRes3
      ORDER BY os_id
  ELSE
    SELECT os_id, os_name, cid, id, cno, name, _ApplID, _PerfMonProduct, _OmegamonUserID, _OmegamonPassword, _Interval=CONVERT(NVARCHAR(255),_Interval,108), _LogicalRows, target_os
      FROM #uploadGetOmegRes3
      ORDER BY os_id

  -- assert the facts INTO thre rule engine
  EXEC @stat = asisp_declarecursor asisp_uploadGetOmegRes_c3, 'SELECT cid, id FROM #uploadGetOmegRes3', 1
  IF @stat < 0
  BEGIN
     ROLLBACK TRANSACTION asisp_uploadGetOmegRes
     RETURN -3000
  END
  OPEN asisp_uploadGetOmegRes_c3
  FETCH NEXT FROM asisp_uploadGetOmegRes_c3 INTO @obj_cid, @obj_id
  WHILE @@fetch_status <> -1
  BEGIN
    SELECT @cmd='(assert (OmegamonLogonSent (cid "'+RTRIM(@obj_cid)+'") (id '+CONVERT(NVARCHAR(255),@obj_id)+')))'
    RAISERROR('asisp_uploadGetOmegRes: %s', 0, 1, @cmd)
    EXEC sp_sendrulecmd 'MVSUpload', @cmd
    FETCH NEXT FROM asisp_uploadGetOmegRes_c3 INTO @obj_cid, @obj_id
  END
  DEALLOCATE asisp_uploadGetOmegRes_c3
  EXEC sp_sendrulecmd 'MVSUpload', '(run)'

  IF @bMarkConnectedStatus IS NOT NULL
  BEGIN
    SELECT @status=v.label FROM enumeration e, enum_value v
      WHERE e.name='OmegamonStatus'
        AND e.eid=v.eid
        AND value=@bMarkConnectedStatus
    RAISERROR('asisp_uploadGetOmegRes: marking all OMGR''s as ''%s'' associated with cid=%s id=%d', 0, 1, @status, @cid, @id)
    UPDATE OmegamonLogin_A
      SET _LastOmegamonStatus=@bMarkConnectedStatus
      FROM link l, OmegamonLogin_A a, #uploadGetOmegRes3 t
      WHERE a.id=dst_id
        AND src_cid=t.cid
        AND src_id=t.id
        AND dst_cid='OMGL' 
        AND deleted=0
  END

  DROP TABLE #uploadGetOmegRes3

  -- Finish up transaction
  IF @tcount = 0
    COMMIT TRANSACTION asisp_uploadGetOmegRes
GO
