PRINT 'Creating procedure cl_attrToStr'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE type='P' AND name='cl_attrToStr')
  DROP PROCEDURE cl_attrToStr
GO

CREATE PROCEDURE cl_attrToStr
@cname NVARCHAR(24),
@astr NVARCHAR(512) OUTPUT, 
@type NVARCHAR(16) = 'where'
AS  
  -- input in #attrs_in
  -- create table #attrs_in (keyword NVARCHAR(64), value NVARCHAR(255), cmptype NVARCHAR(16))
  RAISERROR('cl_attrToStr: @cname=%s, @astr OUT, @type=%s', 0, 1, @cname, @type)

  DECLARE @akey NVARCHAR(64), @aval NVARCHAR(255), @sql NVARCHAR(512), @cmp NVARCHAR(16), @akeydup NVARCHAR(255)
  CREATE TABLE #validattrs(attr NVARCHAR(64))
  SET @astr = ''

  SET @sql = 'INSERT #validattrs SELECT c.name FROM sysobjects o, syscolumns c WHERE o.name=''' + 
	       @cname + '_V''' + ' AND o.id=c.id'
  EXEC (@sql)

  DECLARE attr_c CURSOR FOR SELECT keyword, value, cmptype FROM #attrs_in 
    WHERE keyword IN (SELECT attr FROM #validattrs) OR
          keyword IN (SELECT LTRIM(STUFF(attr, 1, 1, '')) FROM #validattrs)
  OPEN attr_c
  FETCH NEXT FROM attr_c INTO @akey, @aval, @cmp

  WHILE @@FETCH_STATUS <> -1 BEGIN
    SET @akeydup = @akey
    IF @akey <> 'name' AND @akey <> 'description' SET @akey = '_' + @akey

    IF @type = 'set'		
      SET @astr = @astr + ', @' + @akey + '=''' + @aval + ''''
    ELSE IF @type = 'asisp_create'
      SET @astr = @astr + ', @' + @akeydup + '=''' + @aval + ''''
    ELSE 
      SET @astr = @astr + ', ' + @akey + @cmp + '''' + @aval + ''''

    FETCH NEXT FROM attr_c INTO @akey, @aval, @cmp
  END
  DEALLOCATE attr_c

  IF LEFT(@astr, 3) = ' , '
    SET @astr = RIGHT(@astr, LEN(@astr)-3)    -- removing leading [, ]

  IF @type = 'where' AND @astr <> ''
    SET @astr = 'WHERE ' + REPLACE(@astr, ', ', ' AND ')
  
