PRINT 'Creating procedure cl_autoPlacement'

IF EXISTS (SELECT * FROM sysobjects WHERE type='P' AND name='cl_autoPlacement')
  DROP PROCEDURE cl_autoPlacement
GO

CREATE PROCEDURE cl_autoPlacement
@name NVARCHAR(128),
@arg NVARCHAR(255), 
@cid ClassID OUTPUT,
@oid ObjID OUTPUT
AS
  -- Currently this supports only PHYC links
  RAISERROR('cl_autoPlacement: @name=%s, @arg=%s, @cid=%s OUT, @oid=%d OUT', 0, 1, @name, @arg, @cid, @oid)

  DECLARE @argout NVARCHAR(255), @error NVARCHAR(128), @idx INT, @sql NVARCHAR(512), @cname NVARCHAR(24)
  SET @oid = 0
  SET @cid = ''

  -- get only ONE matching set of conditions
  SELECT @name=name FROM CL_AutoPlacement WHERE name LIKE @name
  SELECT _in, _out, seq INTO #placement FROM CL_AutoPlacement WHERE name=@name

  EXEC gemsp_get_first_match '#placement', @arg, @argout OUTPUT
  IF @argout IS NOT NULL BEGIN
    SET @error = NULL
    EXEC gemsp_substitute_hostname @arg, @argout OUTPUT, @error OUTPUT
  END

  IF @argout IS NOT NULL AND @error IS NULL BEGIN

    SET @idx = CHARINDEX('_to_', @name)
    IF @idx > 0 SET @cname = RIGHT(@name, (LEN(@name)-(@idx+3)))
    SELECT @cid=cid FROM obj_class WHERE cname=@cname
    
    CREATE TABLE #pl_oids (oid ObjID)
/*
    SET @sql = 'INSERT #pl_oids SELECT id FROM ' + @cname + '_V WHERE name=''' + @argout + 
      ''' AND id IN (SELECT dst_id FROM containment WHERE dst_cid = ''' + @cid + ''' AND deleted = 0)'
*/
    SET @sql = 'INSERT #pl_oids SELECT id FROM ' + @cname + '_V WHERE name=''' + @argout + 
  	       ''' AND deleted = 0'
    EXEC (@sql)   
    SELECT @oid=oid FROM #pl_oids

    -- need to create the resource
    IF @oid = 0 BEGIN
      IF @cid = 'ENT' EXEC @oid = asisp_createENT @argout, 'BUSC', 1
      ELSE BEGIN
        DECLARE @pcid ClassID, @poid ObjID
        SET @name = @cname + '_to_%'
        EXEC cl_autoPlacement @name, @argout, @pcid OUTPUT, @poid OUTPUT
 
	IF @poid > 0 AND @pcid <> '' BEGIN
          SET @sql = 'asisp_create' + @cid
          EXEC @oid = @sql @argout, @pcid, @poid
        END
      END
    END
  END


