PRINT 'Creating procedure cl_clearEXCP'

IF EXISTS (SELECT * FROM sysobjects WHERE type='P' AND name='cl_clearEXCP')
  DROP PROCEDURE cl_clearEXCP
GO

CREATE PROCEDURE cl_clearEXCP
@cid ClassID,
@oid ObjID,
@action NVARCHAR(8) = 'reset'
AS
  RAISERROR('cl_clearEXCP: @cid=%s, @oid=%d, @action=%s', 0, 1, @cid, @oid, @action)

  DECLARE @excpname ObjName, @time DATETIME
  DECLARE excp_c CURSOR FOR SELECT name FROM Exception_V 
    WHERE _ParentCID=@cid AND _ParentID=@oid AND deleted=0
  OPEN excp_c
  FETCH NEXT FROM excp_c INTO @excpname
 
  WHILE @@FETCH_STATUS <> -1 BEGIN
    SET @time = CURRENT_TIMESTAMP

    -- clear previous exception if exists
    EXEC asisp_createEXCP @name=@excpname, @parent_cid=@cid, @parent_id=@oid, @DATE=@time,
                          @TIME=@time, @EXCP_NAME=@excpname, @EXCP_CD='OK', 
	                  @AlertState=-1, @Priority=-1      

    -- create new exception
    IF @action <> 'remove'
      EXEC asisp_createEXCP @name=@excpname, @parent_cid=@cid, @parent_id=@oid, @DATE=@time, 
			    @TIME=@time, @EXCP_NAME=@excpname, @EXCP_CD='UNKNOWN', 
                            @AlertState=1, @Priority=5          
    FETCH NEXT FROM excp_c INTO @excpname
  END
  DEALLOCATE excp_c



