SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[cl_deleteLinkRule]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[cl_deleteLinkRule]
GO




/* Given a rule id, remove it from the CL_LinkRules table.                                                            
 */

CREATE PROCEDURE cl_deleteLinkRule @rule_id     INT
AS

RAISERROR( 'cl_deleteLinkRule: @rule_id=%d', 0, 1, @rule_id )

-- Standard transaction logic
DECLARE @tcount INT
SELECT @tcount = @@TRANCOUNT
IF @tcount = 0
  BEGIN TRAN cl_deleteLinkRule                     
ELSE
  SAVE TRAN cl_deleteLinkRule                     


DELETE FROM CL_LinkRules WHERE IDENTITYCOL = @rule_id                   

IF @@ERROR <> 0 BEGIN
  RAISERROR( 'error trying to delete from CL_LinkRules for rule id=%d', 0, 1, @rule_id )
  ROLLBACK TRAN cl_deleteLinkRule
  RETURN -30000
END

RAISERROR( 'deleted from CL_LinkRules for rule id=%d', 0, 1, @rule_id )

-- commit transaction
IF @tcount = 0                         
  COMMIT TRAN cl_deleteLinkRule                   

RETURN 0          





GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

