PRINT 'Creating procedure cl_findOid'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE type='P' AND name='cl_findOid')
  DROP PROCEDURE cl_findOid
GO

CREATE PROCEDURE cl_findOid
@cid NVARCHAR(24)
AS  
  -- input in #attrs_in
  -- all the matched object ids in #oids, so the caller should create both tables
  RAISERROR('cl_findOid: @cid=%s', 0, 1, @cid)

  DECLARE @cname NVARCHAR(24), @astr NVARCHAR(512), @sql NVARCHAR(768), @instid NVARCHAR(255), @cmp NVARCHAR(16)
  SELECT @cname=cname FROM obj_class WHERE cid=@cid

  -- find resource using instid
  SET @instid = ''
  SET @cmp = '='
  TRUNCATE TABLE #oids

  SELECT @instid=value, @cmp=cmptype FROM #attrs_in WHERE keyword='instid'
  IF @cmp = '='
    INSERT #oids SELECT oid FROM CL_IDCache 
      WHERE cid=@cid AND keyword='CL_InstID' AND value=@instid AND deleted=0
  ELSE
    INSERT #oids SELECT oid FROM CL_IDCache 
      WHERE cid=@cid AND keyword='CL_InstID' AND value LIKE @instid AND deleted=0
  IF @@ROWCOUNT > 0 
    RETURN 

  -- find resource using sql-match, search CL_IDCache first, then cname_V 
  EXEC cl_attrToStr @cname, @astr OUTPUT

  IF @astr <> '' BEGIN  
/*
    INSERT #oids SELECT oid FROM CL_IDCache 
      WHERE cid=@cid AND keyword='CL_WHERE' AND value=@astr AND deleted=0
    IF @@ROWCOUNT > 0 
      RETURN 
*/
    DECLARE @tmp NVARCHAR(768)
    SET @tmp = '''' + REPLACE(@astr, '''', '''''') + ''''

    -- getting live resources using <cname>_V table
/*
    SET @sql = 'INSERT CL_IDCache SELECT id, ''' + @cid + ''', ''CL_WHERE'', ' + @tmp +
	       ', '''', CURRENT_TIMESTAMP, 0 FROM ' + @cname + '_V ' + @astr + ' AND deleted=0'
*/
    -- DONT cache the WHERE clause to find objectID as there is no guarantee of 
    -- it being up to date
    SET @sql = 'INSERT #oids SELECT id FROM ' + @cname + '_V ' + @astr + ' AND deleted=0'
    EXEC (@sql)
/*
    INSERT #oids SELECT oid FROM CL_IDCache 
      WHERE cid=@cid AND keyword='CL_WHERE' AND value=@astr AND deleted=0
*/
  END
