PRINT 'Creating cl_getCID'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE type='P' AND name='cl_getCID')
  DROP PROCEDURE cl_getCID
GO

CREATE PROCEDURE cl_getCID
@class NVARCHAR(255),
@cid ClassID OUTPUT
AS
  RAISERROR('cl_getCID: @class=%s, @cid OUT', 0, 1, @class)
  
  DECLARE @idx INT, @prod NVARCHAR(64), @ver NVARCHAR(64)
  SET @cid = ''

  SET @idx = CHARINDEX(';', @class)
  IF @idx > 0 BEGIN
    SET @prod = LEFT(@class, (@idx-1))
    SET @ver = RIGHT(@class, (LEN(@class)-@idx))
    SELECT @cid=cid FROM GEMLookupCID WHERE prodname=@prod AND version=@ver
  END
  ELSE
    SELECT @cid=cid FROM obj_class WHERE cname=@class

