PRINT 'Creating procedure cl_getLocalTime'

IF EXISTS (SELECT * FROM sysobjects WHERE type='P' AND name='cl_getLocalTime')
  DROP PROCEDURE cl_getLocalTime
GO

CREATE PROCEDURE cl_getLocalTime
@time NVARCHAR(255),
@tout DATETIME OUTPUT
AS

  RAISERROR('cl_getLocalTime: @time=%s, @disp OUT', 0, 1, @time)
  SET @tout = GETDATE()

  -- If @time is int, its assumed to be the value in seconds from epoch 
  IF ISNUMERIC(@time) = 1 BEGIN
    DECLARE @deltaGMT INT
   
    -- convert epoch in to GMT
    SET @tout = DATEADD(ss, CAST(@time AS INT), 'Jan 01 1970')  

    -- get difference between LOCAL and GMT time from registry
    EXEC master.dbo.xp_regread 'HKEY_LOCAL_MACHINE',
    			       'SYSTEM\CurrentControlSet\Control\TimeZoneInformation',
			       'ActiveTimeBias', 
			       @deltaGMT OUTPUT

    SET @tout = DATEADD(minute, @deltaGMT, @tout)
  END





