PRINT 'Creating procedure cl_getSymbolic'

IF EXISTS (SELECT * FROM sysobjects WHERE type='P' AND name='cl_getSymbolic')
  DROP PROCEDURE cl_getSymbolic
GO

CREATE PROCEDURE cl_getSymbolic
@cname NVARCHAR(24),
@id ObjID, 
@insym NVARCHAR(255),
@outsym NVARCHAR(255) OUTPUT
AS
  RAISERROR('cl_getSymbolic: @cname=%s, @id=%d, @insym=%s, @outsym=%s OUT', 0, 1, @cname, @id, @insym, @outsym)

  DECLARE @idx1 INT, @idx2 INT, @len INT
  DECLARE @tmpstr NVARCHAR(255), @tmpout NVARCHAR(255), @symb NVARCHAR(32), @symbout NVARCHAR(255), @sql NVARCHAR(255)
  CREATE TABLE #output (out NVARCHAR(255) NULL)

  SET @tmpstr = @insym
  SET @idx1 = CHARINDEX('%', @tmpstr)
 
  IF @idx1 > 0 BEGIN  
    WHILE @idx1 > 0 BEGIN

      IF @tmpout IS NULL
        SET @tmpout = LEFT(@tmpstr, (@idx1-1))
      ELSE      
        SET @tmpout = @tmpout + LEFT(@tmpstr, (@idx1-1))
      
      -- replacing space with # as len eats up trailing blanks
      -- Also, column names do not have spaces 
      SET @len = LEN(REPLACE(@tmpstr, ' ', '#'))	
      SET @tmpstr = SUBSTRING(@tmpstr, @idx1, (@len-@idx1+1))
      SET @idx2 = CHARINDEX('%', @tmpstr, 2)

      IF @idx2 > 0 BEGIN
        SET @symb = SUBSTRING(@tmpstr, 2, @idx2-2)    

	SET @sql = 'INSERT #output SELECT ' + @symb + ' FROM ' + @cname 
	 	   + '_V WHERE id=' + CAST(@id AS NVARCHAR)
	EXEC (@sql)

	IF @@ERROR > 0 SET @symbout = '%' + @symb + '%'
        ELSE SELECT @symbout=out FROM #output

        IF @tmpout IS NULL
          SET @tmpout = RTRIM(@symbout)
        ELSE
          SET @tmpout = @tmpout + RTRIM(@symbout)

        SELECT @len = LEN(REPLACE(@tmpstr, ' ', '#'))
        SELECT @tmpstr = SUBSTRING(@tmpstr, (@idx2+1), (@len-@idx2))           
      END
      ELSE BEGIN
	SELECT @outsym = @tmpout + @tmpstr
        RETURN
      END
      SELECT @idx1 = CHARINDEX('%', @tmpstr)
    END		-- end of while

    SELECT @outsym = @tmpout + @tmpstr 
  END
  ELSE SET @outsym = @insym
