PRINT 'Creating procedure cl_logStatus'
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type='P' AND name='cl_logStatus')
  DROP PROCEDURE cl_logStatus
GO

CREATE PROCEDURE cl_logStatus
@trid INT,
@evtid INT,
@disp VARCHAR(8000), 
@status NVARCHAR(8) = 'OK'
AS
  RAISERROR('cl_logStatus: @trid=%d, @evtid=%d, @disp=%s, @status=%s', 0, 1, @trid, @evtid, @disp, @status)

  -- Log when disposition is non-empty
  IF @disp <> '' BEGIN
    -- removing leading [ , ]
    IF LEFT(@disp, 3) = ' , '
      SET @disp = RIGHT(RTRIM(@disp), LEN(@disp)-3) 

    INSERT CL_Status VALUES (@trid, @evtid, @status, @disp, CURRENT_TIMESTAMP)
  END
 
  
