PRINT 'Creating procedure cl_processSPCalls'

IF EXISTS (SELECT * FROM sysobjects WHERE type='P' AND name='cl_processSPCalls')
  DROP PROCEDURE cl_processSPCalls
GO

CREATE PROCEDURE cl_processSPCalls
AS
  RAISERROR('cl_processSPCalls: ', 0, 1)

  DECLARE @sql NVARCHAR(4000), @ts TIMESTAMP, @error NVARCHAR(64), @state TINYINT

PROCESS_NEXT:
  DECLARE sp_c CURSOR STATIC FOR SELECT sp_call, timestp FROM CL_Scheduled_SPCalls WHERE state=0 
    ORDER BY timestp
  OPEN sp_c
  FETCH NEXT FROM sp_c INTO @sql, @ts

  WHILE @@FETCH_STATUS <> -1 BEGIN
    EXEC (@sql)
    SET @error = @@ERROR

    IF @error = '0' SET @state = 1
    ELSE SET @state = 2
    UPDATE CL_Scheduled_SPCalls SET disposition='rc = '+@error, state=@state
      WHERE timestp=@ts

    FETCH NEXT FROM sp_c INTO @sql, @ts
  END
  DEALLOCATE sp_c

  IF EXISTS (SELECT * FROM CL_Scheduled_SPCalls WHERE state=0)
    GOTO PROCESS_NEXT
