-- $Header:   //Archive/Pvcsroot/Archive_NLS/Db/Sql/db2ResourceViewDb.sqv   1.0   Jul 24 2001 16:14:28   Forthman  $
--
-- db2ResourceViewDb.sql
--
-- Defines the GetDB2Objects method, AND its supporting references

SET NOCOUNT ON
GO


--------------------------------------------------------------------------------------------------------
-- asisp_updateManagedObjectTypesEnum
PRINT 'Creating PROCEDURE asisp_updateManagedObjectTypesEnum'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'asisp_updateManagedObjectTypesEnum' AND type = 'P')
  DROP PROCEDURE asisp_updateManagedObjectTypesEnum
GO

-- $Archive:   //Archive/Pvcsroot/Archive_NLS/Db/Sql/db2ResourceViewDb.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jul 24 2001 16:14:28  $
-- $Author:   Forthman  $
CREATE PROCEDURE asisp_updateManagedObjectTypesEnum
AS
  SET NOCOUNT ON

  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN updateManagedObjectTypesEnum
  ELSE
    SAVE TRAN updateManagedObjectTypesEnum

  DECLARE @eid INT
  SELECT @eid = eid FROM Meta..enumeration_table_BASE WHERE name = 'ManagedObjectTypes'
  IF @eid IS NULL
  BEGIN
    ROLLBACK TRAN updateManagedObjectTypesEnum
    RETURN -30000
  END

  DELETE FROM Meta..enum_value_table_LOCAL WHERE eid = @eid
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRAN updateManagedObjectTypesEnum
    RETURN -30000
  END

  DELETE FROM Meta..enum_value_table_BASE WHERE eid = @eid
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRAN updateManagedObjectTypesEnum
    RETURN -30000
  END

  CREATE TABLE #ordered_cid (cid ClassID, row INT IDENTITY(1,1))
  INSERT INTO #ordered_cid(cid)
    SELECT i.cid
    FROM isa_chain AS i JOIN obj_class AS c ON c.cid = i.cid
    WHERE i.base_cid = 'MNO2' AND c.flag_abstract = 0
    AND i.cid NOT IN ('IMPG', 'IMTX', 'IMDA', 'IMAR', 'IMBM', 'D2DB', 'D2TS', 'D2TB', 'D2IX', 'D2TP', 'D2IP', 'D2VF', 'D2VW' )
    ORDER BY c.label
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRAN updateManagedObjectTypesEnum
    RETURN -30000
  END

  INSERT INTO Meta..enum_value_table_BASE(eid, name, value, val_cid)
    SELECT e.eid, c.cname, o.row, o.cid
    FROM
      enumeration AS e,
      #ordered_cid AS o
        JOIN obj_class AS c ON c.cid = o.cid
    WHERE
      e.name = 'ManagedObjectTypes'
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRAN updateManagedObjectTypesEnum
    RETURN -30000
  END

  INSERT INTO Meta..enum_value_table_LOCAL(eid, value, langid, label, description)
    SELECT ev.eid, ev.value, ocl.langid, ocl.label, ocl.description
    FROM
      Meta..enum_value_table_BASE AS ev
        JOIN Meta..obj_class_table_LOCAL AS ocl ON ocl.cid = ev.val_cid
    WHERE
      ev.eid = @eid
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRAN updateManagedObjectTypesEnum
    RETURN -30000
  END

  UPDATE Meta..DatabaseVersion SET verno = verno + 1

  IF @tcount = 0
    COMMIT TRAN updateManagedObjectTypesEnum
GO

--------------------------------------------------------------------------------------------------------
-- UPDATE ManagedObjectType Enumeration
PRINT 'Updating ManagedObjectType Enumeration'
GO

EXEC asisp_updateManagedObjectTypesEnum
GO


--------------------------------------------------------------------------------------------------------
-- asisp_updateDB2ObjectTypesEnum
PRINT 'Creating PROCEDURE asisp_updateDB2ObjectTypesEnum'
GO

IF EXISTS ( SELECT * FROM sysobjects WHERE name = 'asisp_updateDB2ObjectTypesEnum' AND type = 'P')
  DROP PROCEDURE asisp_updateDB2ObjectTypesEnum
GO

-- $Archive:   //Archive/Pvcsroot/Archive_NLS/Db/Sql/db2ResourceViewDb.sqv  $
-- $Revision:   1.0  $
-- $Date:   Jul 24 2001 16:14:28  $
-- $Author:   Forthman  $
CREATE PROCEDURE asisp_updateDB2ObjectTypesEnum
AS
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN updateDB2ObjectTypesEnum
  ELSE
    SAVE TRAN updateDB2ObjectTypesEnum

  DECLARE @eid INT
  SELECT @eid = eid FROM Meta..enumeration_table_BASE WHERE name = 'DB2ObjectTypes'
  IF @eid IS NULL
  BEGIN
    ROLLBACK TRAN updateDB2ObjectTypesEnum
    RETURN -30000
  END

  DELETE FROM Meta..enum_value_table_LOCAL WHERE eid = @eid
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRAN updateDB2ObjectTypesEnum
    RETURN -30000
  END

  DELETE FROM Meta..enum_value_table_BASE WHERE eid = @eid
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRAN updateDB2ObjectTypesEnum
    RETURN -30000
  END

  CREATE TABLE #ordered_cid (cid ClassID, row INT IDENTITY(1,1))
  INSERT #ordered_cid(cid)
    SELECT i.cid
    FROM isa_chain AS i JOIN obj_class AS c ON c.cid = i.cid AND i.base_cid = 'D2BA'
    WHERE c.flag_abstract = 0 
    ORDER BY c.label

  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRAN updateDB2ObjectTypesEnum
    RETURN -30000
  END

  INSERT INTO Meta..enum_value_table_BASE(eid, name, value, val_cid)
    SELECT e.eid, c.cname, o.row, o.cid
    FROM
      enumeration AS e,
      #ordered_cid AS o
        JOIN obj_class AS c ON c.cid = o.cid
    WHERE
      e.name = 'DB2ObjectTypes'
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRAN updateDB2ObjectTypesEnum
    RETURN -30000
  END

  INSERT INTO Meta..enum_value_table_LOCAL(eid, value, langid, label, description)
    SELECT ev.eid, ev.value, ocl.langid, ocl.label, ocl.description
    FROM
      Meta..enum_value_table_BASE AS ev
        JOIN Meta..obj_class_table_LOCAL AS ocl ON ocl.cid = ev.val_cid
    WHERE
      ev.eid = @eid
  IF @@ERROR <> 0
  BEGIN
    ROLLBACK TRAN updateDB2ObjectTypesEnum
    RETURN -30000
  END

  UPDATE Meta..DatabaseVersion SET verno = verno + 1

  IF @tcount = 0
    COMMIT TRAN updateDB2ObjectTypesEnum
GO

------------------------------------------------------------------------------------
-- UPDATE DB2ObjectType Enumeration
PRINT 'UPDATE DB2ObjectType Enumeration'
GO

EXEC asisp_updateDB2ObjectTypesEnum
GO

------------------------------------------------------------------------------------
-- _GetDB2Objects
PRINT "Creating PROCEDURE _GetDB2Objects"
IF EXISTS (SELECT * FROM sysobjects WHERE name = '_GetDB2Objects' AND type = 'P')
  DROP PROCEDURE _GetDB2Objects 
GO

CREATE PROCEDURE _GetDB2Objects
-- $Archive:   //Archive/Pvcsroot/Archive_NLS/Db/Sql/db2ResourceViewDb.sqv  $
-- $Revision:   1.0  $ 
-- $Date:   Jul 24 2001 16:14:28  $
-- $Author:   Forthman  $
  @cid               ClassID,
  @id                ObjID,
  @OrLocationPattern1  NVARCHAR(255) = NULL,
  @OrLocationPattern2  NVARCHAR(255) = NULL,
  @OrLocationPattern3  NVARCHAR(255) = NULL,
  @NamePattern       NVARCHAR(255) = NULL,
  @MinAlert          INT = 0,
  @MinPriority       INT = 0,
  @OpenNotes         INT = 2,
  @ObjectType        INT = 0, 
  @debug              INT = 0
AS
  RAISERROR( '_GetDB2Objects: Called AS _GetDB2Objects @cid=%s, @id=%d, @OrLocationPattern1=%s, @OrLocationPattern2=%s, @OrLocationPattern3=%s, @NamePattern=%s, @MinAlert=%d, @MinPriority=%d, @OpenNotes=%d, @ObjectType=%d, @debug=%d', 0, 1, @cid, @id, @OrLocationPattern1, @OrLocationPattern2, @OrLocationPattern3, @NamePattern, @MinAlert, @MinPriority, @OpenNotes, @ObjectType, @debug)  

  SET NOCOUNT ON
  SET ROWCOUNT 0

  -- Initialization FOR the timings of steps
  DECLARE @startdate DATETIME
  DECLARE @nowdate   DATETIME
  DECLARE @stepdate  DATETIME
  SELECT @nowdate    = GETDATE()
  SELECT @stepdate   = @nowdate
  SELECT @startdate  = @stepdate
  DECLARE @stepname  NVARCHAR(20)
  SELECT @stepname = NULL
  DECLARE @steptime INT
  DECLARE @totaltime INT

  -- Timing header
  IF @debug >= 1
  BEGIN
    RAISERROR( 'Timings: Stepname             (ms_step/ms_total)', 0, 1)
  END

  -- Timing of Step
  IF @debug >= 1
  BEGIN
    SELECT @stepname = 'INIT'
    SELECT @nowdate    = GETDATE()
    SELECT @steptime = DATEDIFF( ms, @stepdate, @nowdate)
    SELECT @totaltime = DATEDIFF( ms, @startdate, @nowdate)
    RAISERROR( 'Timings: %-20s (%7d/%8d)', 0, 1, @stepname, @steptime, @totaltime)
    SELECT @stepdate   = @nowdate
  END

  -- Initialization of UPPER threshold FOR the number of records returned.
  DECLARE @maxRowCount AS INT
  SELECT @maxRowCount = 2000

  -- Get list of DB2 objects under the calling object using object linking 
  CREATE TABLE #descendent
  (
    cid   ClassID PRIMARY KEY (cid, id),
    id    ObjID,
    gen   INT
  )

  DECLARE @where NVARCHAR(500)
  SET @where = 'IN (SELECT cid FROM isa_chain WHERE base_cid = ''D2BA'')'

  DECLARE @ObjectTypeCid NVARCHAR(4)
  SELECT @ObjectTypeCid = NULL

  -- Modify the WHERE clause based ON object type requested to get the bare minumim
  -- Either all, just itself, OR just the classes need FOR the physical containments
  -- IF no object type was specified leave the WHERE clause alone
  IF @ObjectType <> 0 
  BEGIN
    -- @ObjectType has been selected get the cid ( @ObjectTypeCid )
    SELECT  @ObjectTypeCid = ev.val_cid FROM enum_value AS ev 
    JOIN enumeration AS e ON ev.eid = e.eid
    WHERE e.name = 'DB2ObjectTypes' AND ev.value = @ObjectType

    SELECT @where = 'IN (''' + ev.val_cid + ''')'
    FROM enum_value AS ev JOIN enumeration AS e ON ev.eid = e.eid
    WHERE e.name = 'DB2ObjectTypes' AND ev.value = @ObjectType
  END

  IF @debug >=2
  BEGIN
    PRINT 'Before EXEC asisp_descendents @cid, @id, @where call'
    SELECT @cid, @id, @where
  END

  -- populate #descendents TABLE with those objects with link dependencies
  EXEC asisp_descendents @cid, @id, @where

  IF @debug >= 1
  BEGIN
    SELECT @stepname = 'asisp_descendents'
    SELECT @nowdate    = GETDATE()
    SELECT @steptime = DATEDIFF( ms, @stepdate, @nowdate)
    SELECT @totaltime = DATEDIFF( ms, @startdate, @nowdate)
    RAISERROR( 'Timings: %-20s (%7d/%8d)', 0, 1, @stepname, @steptime, @totaltime)
    SELECT @stepdate   = @nowdate
  END

  IF @debug >=2
  BEGIN
    PRINT '# of rows IN #descendent: ' 
    SELECT COUNT(*) FROM #descendent
    PRINT 'SELECT * FROM #descendent: '
    SELECT * FROM #descendent
  END

  -- Populate #obj TABLE with all attributes of objects who should be returned
  CREATE TABLE #obj
  (
    src_cid            ClassID NULL,
    src_id             ObjID NULL,
    cid                ClassID,
    id                 ObjID,
    name               ObjName NULL,
    Location           NVARCHAR(1000) NULL,
    Type               NVARCHAR(40) NULL,
    _AlertStateID      INT NULL,
    _PriorityID        INT NULL,
    _CurrentStateID    INT NULL,
    _DesiredStateID    INT NULL,
    _HasOwnershipNote  TINYINT NULL,
    Description        NVARCHAR(255) NULL
  )
  -- Populate #obj TABLE with all objects known by descendents links
  INSERT #obj
    SELECT c.src_cid, c.src_id, dst_cid, dst_id, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL
    FROM #descendent AS d 
      JOIN link AS c ON c.dst_cid = d.cid AND c.dst_id = d.id AND c.deleted = 0
      JOIN link_type AS lt ON lt.link_type = c.link_type
    WHERE
      (lt.flag_containment=1 OR lt.flag_parent_child=1)

  IF @debug >= 1
  BEGIN
    SELECT @stepname = 'populate by link'
    SELECT @nowdate    = GETDATE()
    SELECT @steptime = DATEDIFF( ms, @stepdate, @nowdate)
    SELECT @totaltime = DATEDIFF( ms, @startdate, @nowdate)
    RAISERROR( 'Timings: %-20s (%7d/%8d)', 0, 1, @stepname, @steptime, @totaltime)
    SELECT @stepdate   = @nowdate
  END


  IF @debug >=2
  BEGIN
    PRINT '# of rows IN #obj: ' 
    SELECT COUNT(*) FROM #obj
  END

  IF @debug >=2
  BEGIN
    SELECT @cid, @id 
    PRINT '# of rows IN #obj: After object type filtering.' 
    SELECT COUNT(*) FROM #obj
  END

  SELECT i.cid, i.id, i.name, Location = i._Path, Type = oc.label, i._AlertStateID, i._PriorityID, i._CurrentStateID, i._DesiredStateID, i._HasOwnershipNote, Description = i.description
    INTO #output 
      FROM DB2Base_C AS i
      INNER JOIN #obj AS o ON o.cid = i.cid AND o.id = i.id
      INNER JOIN obj_class AS oc ON oc.cid = i.cid
      WHERE (@ObjectType = 0         OR i.cid = @ObjectTypeCid)
        AND (@MinAlert = 0           OR i._AlertStateID >= @MinAlert)
        AND (@NamePattern IS NULL    OR i.name LIKE @NamePattern)
        AND (@MinPriority = 0        OR i._PriorityID <= @MinPriority) -- yes, priorities work IN reverse!
        AND (@OpenNotes = 2          OR i._HasOwnershipNote = @OpenNotes)
        AND ( (@OrLocationPattern1 IS NULL AND @OrLocationPattern2 IS NULL AND @OrLocationPattern3 IS NULL )
          OR  (    i._Path LIKE @OrLocationPattern1
                OR i._Path LIKE @OrLocationPattern2
                OR i._Path LIKE @OrLocationPattern3
              )
            )

  -- Output columns based ON final result SET
  DECLARE @countRow INT
  SELECT @countRow = @@ROWCOUNT

       
  IF @debug >= 1
  BEGIN
    SELECT @stepname = 'SELECT INTO #output'
    SELECT @nowdate    = GETDATE()
    SELECT @steptime = DATEDIFF( ms, @stepdate, @nowdate)
    SELECT @totaltime = DATEDIFF( ms, @startdate, @nowdate)
    RAISERROR( 'Timings: %-20s (%7d/%8d)', 0, 1, @stepname, @steptime, @totaltime)
    SELECT @stepdate   = @nowdate
  END
	   
  -- Output error message
  IF @countRow > @maxRowCount 
  BEGIN 
    CREATE TABLE #errortext
    (
      _AlertStateID      INT,
      Error              NVARCHAR(100)
    )
    INSERT #errortext
      SELECT _AlertStateID = 3,
      Error = 'The query returned ' + CONVERT( NVARCHAR(8), @countRow) + ' rows, please submit query again with more restrictive criteria.'
    SELECT 
      e._AlertStateID, e.Error
    FROM 
      #errortext AS e
  END
  ELSE
  BEGIN

  -- RETURN Good Results
  SELECT
    obj._AlertStateID,
    obj._HasOwnershipNote,
    obj.Location,
    obj.Type,
    obj.name,
    obj._PriorityID,
    obj._CurrentStateID,
    obj._DesiredStateID,
    obj.Description,
    obj.cid,
    obj.id
  FROM
    #output AS obj
  ORDER BY
    obj.Location
  END

  -- Timing of Step
  IF @debug >= 1
  BEGIN
    SELECT @stepname = 'Result Output'
    SELECT @nowdate    = GETDATE()
    SELECT @steptime = DATEDIFF( ms, @stepdate, @nowdate)
    SELECT @totaltime = DATEDIFF( ms, @startdate, @nowdate)
    RAISERROR( 'Timings: %-20s (%7d/%8d)', 0, 1, @stepname, @steptime, @totaltime)
    SELECT @stepdate   = @nowdate
  END
  DROP TABLE #obj
  DROP TABLE #descendent
GO

SET NOCOUNT OFF
GO

-----------------------------------------------------------------------------------------------------------------------
PRINT 'Done.'
GO
