USE Object
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

/****** Object:  Stored PROCEDURE dbo.gemsp_get_first_match    Script Date: 6/5/00 1:52:03 PM ******/
IF EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[dbo].[gemsp_get_first_match]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[gemsp_get_first_match]
GO


CREATE PROCEDURE gemsp_get_first_match 
  @table NVARCHAR(128), 
  @key NVARCHAR(128), 
  @value NVARCHAR(128) OUTPUT
AS
  RAISERROR('gemsp_get_first_match: @table=%s, @key=%s, @value=%s OUT', 0, 1, @table, @key, @value)

  -- Standard transaction logic
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN gemsp_get_first_match 
  ELSE
    SAVE TRAN gemsp_get_first_match 

  DECLARE @sql NVARCHAR(1024)
  DECLARE @min INT

  CREATE TABLE #value (_out NVARCHAR(128) NOT NULL, seq INT)
  
  SET @sql = 'INSERT INTO #value SELECT _out, seq FROM ' + @table + ' WHERE N''' + @key + ''' like _in'
  EXEC gemsp_print @sql
  EXEC(@sql)

  SET @value = NULL
  SELECT @min = min(seq) FROM #value
  IF @min IS NOT NULL
    SELECT @value = _out FROM #value WHERE seq = @min
  DROP TABLE #value

  -- commit transaction
  IF @tcount = 0 
    COMMIT TRAN gemsp_get_first_match

GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

