IF EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[dbo].[gemsp_processAPMGenericMsg]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[gemsp_processAPMGenericMsg]
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE [gemsp_processAPMGenericMsg] 
		@tbsmclass  NVARCHAR(128)='',  -- contain product;version
		@instanceid NVARCHAR(128)=''  ,
		@instancename NVARCHAR(128)=''  ,
		@probetype NVARCHAR(128)=''  ,
		@probeid NVARCHAR(255)=''  ,
		@probename NVARCHAR(128)=''  ,
		@probeargs NVARCHAR(128)='', 
		@severity NVARCHAR(128)='', 
		@probevalue NVARCHAR(128)='', 
		@probecondition NVARCHAR(128)='', 
		@msg NVARCHAR(255)='',
		@eehost NVARCHAR(128)='',
		@hostos INT,
		@tcphostname NVARCHAR(128)='',
		@tmr NVARCHAR(128)='', 
                @hostnameslot NVARCHAR(128)='',
		@data1 NVARCHAR(128)='',
		@data2 NVARCHAR(128)='',
		@data3 NVARCHAR(128)='',
		@data4 NVARCHAR(128)='',
                @eventtime int=0
AS

RAISERROR('gemsp_processAPMGenericMsg: @tbsmclass=%s, @instanceid=%s, @instancename=%s, 
	  @probetype=%s, @probeid=%s, @probename=%s, @probeargs=%s, @severity=%s, 
	  @probevalue=%s, @probecondition=%s, @msg=%s, @eehost=%s, @hostos=%d, @tcphostname=%s,
	  @tmr=%s, @hostnameslot=%s, @data1=%s, @data2=%s, @data3=%s, @data4=%s', 0, 1,        		
 	  @tbsmclass, @instanceid, @instancename, @probetype, @probeid, @probename, @probeargs, 
	  @severity, @probevalue, @probecondition, @msg, @eehost, @hostos, @tcphostname, 
  	  @tmr, @hostnameslot, @data1, @data2, @data3, @data4)

-- Standard transaction logic
DECLARE @tcount INT
SELECT @tcount = @@TRANCOUNT
IF @tcount = 0
  BEGIN TRAN gemsp_processAPMGenericMsg
ELSE
  SAVE TRAN gemsp_processAPMGenericMsg

DECLARE @h INT, @error NVARCHAR(128)
DECLARE @deleteproc NVARCHAR(16)
DECLARE @componenttype NVARCHAR(64)


CREATE TABLE #thresholdinstances(
	cid	ClassID,
	iid	ObjID)


EXEC gemsp_print 'gemsp_processAPMGenericMsg begins...'

DECLARE @checkslotchanges TINYINT 
DECLARE @instancecreated TINYINT
DECLARE @msglocal NVARCHAR(128)
SELECT @msglocal = 'no further details available'
DECLARE @goodsofar INT
SET @goodsofar = 1
DECLARE @disposition NVARCHAR(128)

DECLARE @print_string NVARCHAR(1024)

SET @checkslotchanges = 1
SET @instancecreated = 0 


IF @probeid IS NULL OR @probeid = ''
  SET @probeid = @probename

--- jpf concern about length of msg should we check the length AND TRUNCATE
IF @probeid IS NULL OR @probeid = ''
  SET @probeid = @msg


IF @probeid IS NULL OR @probeid = '' BEGIN
  SET @disposition = 'This event doesn''t seem to be a REAL threshold. We''ll ignore it'
  goto GETOUT
END 


IF @msg IS NULL OR @msg = '' BEGIN
  SET @msg = '(No description provided)'
END 


-- this event has a probeid so it IS a REAL threshold

DECLARE @placementhostname NVARCHAR(128)
DECLARE @oproduct NVARCHAR(128)
DECLARE @oversion NVARCHAR(128)

SET @placementhostname = @tcphostname


DECLARE @productName NVARCHAR(64)
DECLARE @version NVARCHAR(64)
DECLARE @manufacturer NVARCHAR(64)

DECLARE @cid ClassID
DECLARE @oid ObjID
DECLARE @holdrowcount INT


DECLARE @time DATETIME
declare @timetemp nvarchar(64)

--- now prepare the timestamp from the one that was passed in 
set @timetemp = cast(@eventtime as nvarchar)
IF @eventtime is null or @eventtime=0 SELECT @time = CURRENT_TIMESTAMP  
ELSE exec cl_getLocalTime @time=@timetemp, @tout=@time output



-- BEGIN the process to pull out product AND version FROM input @tbsmclass 
DECLARE @mpv_expr NVARCHAR(64)   /*pulls out pv */
SET @mpv_expr = '\(.*\);\(.*\);'  

IF SUBSTRING(@tbsmclass, len(@tbsmclass), 1) <> ';'
  SET @tbsmclass = @tbsmclass + ';'

EXEC @h = master..xp_regexmatch @mpv_expr, @tbsmclass , @h OUT, @error OUT
IF @h IS NULL BEGIN
     SET @disposition =  ' Failed to parse product/version ...  regular expression match failed' 
     SET @goodsofar = 0 
    END
ELSE BEGIN
    DECLARE @c INT, @i INT
    EXEC master..xp_regexmatcharraycount @h, @c OUT
      IF @c = 3	BEGIN
		 	EXEC master..xp_regexmatcharrayitem @h, 1, @oproduct OUTPUT
			EXEC master..xp_regexmatcharrayitem @h, 2, @oversion OUTPUT
		END 
      ELSE BEGIN
             SET @disposition =  'Failed to parse product/version ... COUNT of tokens IS NOT three'
             SET @goodsofar = 0 
      END 
      EXEC master..xp_regexmatcharrayfree @h
      SET @h=NULL  -- reset to NULL 

END -- END IF found product version with regular expression check

IF @goodsofar = 0 BEGIN
     goto GETOUT
END 

---- END of pulled out product AND version 

--- jpf need to get out IF goodsofar IS NOT 1 

-- get the CID 

SELECT @componenttype = comptype, @cid = cid, @manufacturer = manufacturer FROM GEMLookupCID WHERE prodname = @oproduct AND version = @oversion
IF @cid IS NOT NULL BEGIN
  SET @print_string = ' product name IS ' + @oproduct + ' version IS ' + @oversion + 'cid = ' + @cid
  EXEC gemsp_print @print_string
END
ELSE BEGIN
     --- jpf added in routing of this message to Common Listener
     ---      need to decide if this should only occur if there is something in the mapping
     ---      table that says we should ... 
     set @disposition =  ' cid not found in gemmapping table driving Common Listener ' + @oproduct + ' version is ' + @oversion
     exec gemsp_processEventtoCL @oproduct, @instanceid,@probetype, @probeid, @probeargs, @severity, @msg, @eventtime
---     SET @disposition =  ' cid NOT found product name IS ' + @oproduct + ' version IS ' + @oversion
     goto GETOUT
END 

---  END get CID

IF @componenttype <> 'generic' SET @checkslotchanges=0

--- now get instance id FOR searches AND creating instance
--- jpf need to ADD IN the hostname slot FOR something ELSE just IN CASE 

DECLARE @displayname NVARCHAR(256)

IF @instanceid IS NULL BEGIN
       SELECT @disposition = 'No Instance ID. Event IS invalid'
       goto GETOUT
END

SET @displayname = @instancename

IF @displayname IS NULL OR @displayname = ''
  SET @displayname = @instanceid

IF @placementhostname IS NOT NULL SET @displayname = @displayname + '@' +  @placementhostname

-- now search FOR the instance IN the IID TABLE
SET @holdrowcount = 0
IF @componenttype = 'generic' BEGIN 
-- this key only makes sense IF component IS generic
   INSERT #thresholdinstances
   SELECT DISTINCT cid=CID, oid=IID FROM GEM_IDLookup
       WHERE CID = @cid
       AND ((key_name = 'KeyGen' AND key_value like @instanceid))

   SET @holdrowcount=@@ROWCOUNT
END 
ELSE 
--- IF it IS NOT a generic event THEN we are matching ON hostnameslot OR tcpipaddress
---     AS the last resort
   IF @hostnameslot IS NOT NULL AND @hostnameslot <> '' BEGIN
      DECLARE @keytofind NVARCHAR(255)
      SET @keytofind = @hostnameslot

      IF @tmr IS NOT NULL SET @keytofind = @keytofind + '|' + @tmr 
      ELSE SET @keytofind = @keytofind + '|%' 

      INSERT #thresholdinstances
      SELECT DISTINCT cid=CID, oid=IID FROM GEM_IDLookup
          WHERE CID = @cid
          AND ((key_name = 'KeyTivName' AND key_value like @keytofind))

       SET @holdrowcount=@@ROWCOUNT
   END

ELSE 
  IF @tcphostname IS NOT NULL AND @tcphostname <> '' BEGIN 
      INSERT #thresholdinstances
      SELECT DISTINCT cid=CID, oid=IID FROM GEM_IDLookup
          WHERE CID = @cid
          AND ((key_name = 'KeyIp' AND key_value like @tcphostname))

       SET @holdrowcount=@@ROWCOUNT
   END  
  
---
-- get the oid
SELECT @oid = iid FROM #thresholdinstances

--- first try to handle the CASE WHERE the tcpipaddress changes AND the resource needs to 
--- be deleted AND THEN rerun through the CREATE process 

IF @holdrowcount > 0 AND @componenttype = 'generic'  BEGIN 
      DECLARE @temp NVARCHAR(255)
      SET @temp = NULL
      EXEC gemsp_getAttribute @cid, @oid, '_TCPHost', @temp OUTPUT

      IF ((@temp IS NOT NULL) AND (@tcphostname IS NULL)) OR 
            ((@temp IS NULL) AND (@tcphostname IS NOT NULL)) OR 
               (@tcphostname <> @temp) 
      BEGIN

        -- send the GONE FOR this oid
         EXEC gemsp_print 'deleting oid since the tcpiphostname changed'
         SELECT @deleteproc = 'delete_' + @cid
         EXEC @deleteproc @oid
        -- now make the rest of the code process this heartbeat AS a first time heartbeat
         SET @oid = NULL
         SET @holdrowcount = 0  --- 
        --- at this point the rest of the code will think that the resource does NOT exist

      END

END


--- no instance at this point

IF @holdrowcount = 0 BEGIN
          EXEC gemsp_print 'did NOT find matches'   

          IF @probetype = 'GONE'BEGIN
             SELECT @disposition = 'Gone message received, no instance created'
             goto GETOUT
          END 

          
          IF @componenttype <> 'generic' BEGIN 
             SELECT @disposition = 'waiting FOR instance to be discovered'
             goto GETOUT
          END 


		  -- no instances but cid EXISTS ... CREATE a instance
          DECLARE @parentid ObjID
          DECLARE @parentclass ClassID

          -- find OR find/CREATE the parent container
          EXEC gemsp_get_parent @cid, @tcphostname, @placementhostname, @hostos, @eehost, 
                                @parentid OUTPUT, @parentclass OUTPUT, @msglocal OUTPUT
         /* we can CREATE the instance since we don't expect a heartbeat FROM normal instrumentation */
         IF @parentid > 0 BEGIN  -- success finding OR creating  parent object 
           DECLARE @timestamp DATETIME
           SELECT @timestamp = GETDATE()
           DECLARE @createproc NVARCHAR(16)
           SELECT @createproc = 'asisp_create' + @cid
           SET @checkslotchanges = 0
           SET @instancecreated = 1
           
           DECLARE @pcid ClassID
           SELECT @pcid=base_cid FROM isa WHERE cid=@cid
           
           IF @pcid = 'GMGN'
             EXEC @oid = @createproc @displayname,
                                     @parentclass,
                                     @parentid,
                                     @instanceid,
                                     @displayname,  -- previous dispname
                                     @eehost,
                                     @tmr,
                                     0,          -- no heartbeat interval
                                     @timestamp,
                                     @manufacturer,
                                     @oproduct,
                                     @tcphostname,
                                     @oversion
           ELSE IF @pcid = 'GMGX' 
             EXEC @oid = @createproc @displayname,
                                     @parentclass,
                                     @parentid,
                                     @data1,
                                     @data2,
                                     @data3,
                                     @data4,
                                     @hostnameslot,
                                     @instanceid,
                                     @displayname,  -- previous dispname
                                     @eehost,
                                     @tmr,
                                     0,          -- no heartbeat interval
                                     @timestamp,
                                     @manufacturer,
                                     @oproduct,
                                     @tcphostname,
                                     @oversion                                 

             IF @oid > 0 BEGIN  --- CREATE worked
                 SET @disposition = 'created cid ' + @cid + ' oid ' + CAST(@oid AS NVARCHAR(10))
                 EXEC gemsp_print @disposition
                 DECLARE @lob_disp NVARCHAR(128)
                 SET @lob_disp = NULL
                 EXEC gemsp_LOBs @cid, @oid, @lob_disp OUTPUT -- put the instance IN a line of business
                 IF @lob_disp IS NOT NULL SET @disposition = @disposition + ', ' + @lob_disp

                 /* we want to cache the new oid so we can pick it up quickly NEXT time the threshold comes IN. */
               --- UPDATE lookup TABLE
                 INSERT INTO GEM_IDLookup (CID, IID, key_name, key_value) 
                   VALUES (@cid, @oid, 'KeyGen', @instanceid)
                END -- created the instance
              ELSE BEGIN -- CREATE failed 
                   RAISERROR('TBSM2007E: %s could not create object', 0, 1, @createproc) with log
                   SET @disposition = 'TBSM2007E: ' + @createproc + ' could NOT CREATE object'
		   SET @goodsofar = 0 
                   END
           END  --- END of success creating parent object 
          ELSE BEGIN  -- failed to find OR CREATE parent object 
            RAISERROR('TBSM2008E: error creating %s object: %s', 0, 1, @cid, @msglocal) with log
            SET @disposition = 'TBSM2008E: error creating ' + @cid + ' object: ' + @msglocal
            SET @goodsofar = 0 
          END

END  --- END of no instances found with initial lookup 

IF @goodsofar = 0 BEGIN
     goto GETOUT
END 

IF @holdrowcount = 0 BEGIN 
    INSERT #thresholdinstances
     SELECT DISTINCT cid=CID, oid=IID FROM GEM_IDLookup
            WHERE CID = @cid
               AND ((key_name = 'KeyGen' AND key_value like @instanceid))
     SET @holdrowcount = @@ROWCOUNT
END 

IF @holdrowcount > 0 AND @probetype = 'GONE' BEGIN
      SELECT @disposition = 'deleted ' + @cid + ' oid ' + CAST(@oid AS NVARCHAR(10))
      SELECT @deleteproc = 'delete_' + @cid
      EXEC @deleteproc @oid
        -- now make the rest of the code process this heartbeat AS a first time heartbeat
      SET @oid = NULL
      SET @holdrowcount = 0
END 

IF @holdrowcount > 0 BEGIN


-- CREATE the exception AND get out 
-- getExceptionType will CREATE the exception object FOR this software component IF necessary
   EXEC asisp_getExceptionType @cid, @cid, @probeid, 1, 5, NULL, 'GEM', 'Dynamically defined' 
   SET @disposition = @disposition + ', processed cid ' + @cid + ': '
-- process each instance 
   DECLARE iCursor CURSOR FOR 
   SELECT cid, iid FROM #thresholdinstances
   OPEN iCursor
   SELECT * FROM #thresholdinstances
   FETCH NEXT FROM iCursor INTO @cid, @oid
   WHILE @@FETCH_STATUS = 0 BEGIN
      SET @print_string = 'top of loop, cid=' + @cid + ', oid=' + CAST(@oid AS NVARCHAR(6))
      EXEC gemsp_print @print_string
      SET @disposition = @disposition + CAST(@oid AS NVARCHAR(10)) + ' '
      -- remove existing exception FOR this threshold IF necessary 
      DECLARE @currState INT
      DECLARE @currPriority INT
            

      EXEC asisp_createEXCP @name=@probeid, @parent_cid=@cid, @parent_id=@oid, @DATE=@time,
                            @TIME=@time, @EXCP_NAME=@probeid, @EXCP_CD='OK', @AlertState=-1, @Priority=-1      
  
    -- CREATE new exception FOR the threshold, reflecting the current severity
      -- get priority	
      SELECT @currState=AlertState, @currPriority=Priority FROM GEMSeverities WHERE Severity = @severity
      IF @currState IS NULL --- USE DEFAULT state AND priority IF incoming IS NOT recognized  jpf need to SET disposition here
          SELECT @currState=AlertState, @currPriority=Priority FROM GEMSeverities WHERE Severity = 'INFORMATIONAL'

      -- SPECIAL CASE STATE MONITOR 
      -- IF this IS the state monitor, we'll force it to always be propagated.  It should only have a Red OR Green
      -- alert state.  IF it's Red, it overrides all other thresholds.  IF it's Green, thresholds will override it.

      IF @probeid = 'State' OR @probeid = 'STATE' SET @currPriority = 1 -- "critical priority" IS always propagated up


--- jpf check what the probe type IS FOR Msg AND exceptions
      IF @probetype IS NULL  OR @probetype NOT like 'MSG'  BEGIN
          
 EXEC asisp_createEXCP @name=@probeid, @parent_cid=@cid, @parent_id=@oid, @DATE=@time, @TIME=@time, 
                            @EXCP_NAME=@probeid, @EXCP_CD=@msg, 
                            @AlertState=@currState, @Priority=@currPriority
      END
      ELSE BEGIN
           SET @currPriority = 1 -- "critical priority" IS always propagated up
           EXEC asisp_createMESG
              @name=@probeid,
              @parent_cid=@cid,
              @parent_id=@oid,
              @DATE=@time,
              @TIME=@time,
              @MESSAGE=@probeid,
              @REASON_CD=@msg,
              @AlertState=@currState,
              @Priority=@currPriority
      END 

      FETCH NEXT FROM iCursor INTO @cid, @oid
    END
  CLOSE iCursor
  DEALLOCATE iCursor
   --- END of creating exception

END 


IF @checkslotchanges = 1 AND @oid IS NOT NULL BEGIN

    DECLARE @previousDispname NVARCHAR(128)
    DECLARE @currentName NVARCHAR(128)
    DECLARE @cmd NVARCHAR(1024)
    DECLARE @cname NVARCHAR(128)
    DECLARE @attrTable NVARCHAR(64)



  -- has the instance's display name changed ON the GEM screen?
    EXEC gemsp_getAttribute @cid, @oid, 'name', @currentName OUTPUT
    EXEC gemsp_getAttribute @cid, @oid, '_PreviousDisplayName', @previousDispname OUTPUT

    -- has the instance's display name changed ON the GEM screen?

    IF @displayname <> @previousDispname BEGIN

       --- start to build the UPDATE sql statement 
       SELECT @cname = cname FROM Meta.dbo.obj_class_table WHERE cid = @cid
       SELECT @attrTable = @cname + '_C'
       --- prefix the command ON just IN CASE part of the command was already built   jpf 
       SELECT @cmd = 'UPDATE ' + @attrTable + ' SET _LastHbTimestamp = ''' + CAST(GETDATE() AS NVARCHAR(128)) + ''' ' 

      SELECT @cmd = @cmd + ', _PreviousDisplayName = ''' + @displayname + ''''

      -- new GEM name only takes effect IF the instance name hasn't been changed ON the TBSM console

      IF @previousDispname = @currentName
        SELECT @cmd = @cmd + ', name = ''' + @displayname + ''''



    END


END 



--- log the event AND the disposition AND THEN get out 
GETOUT:

IF @disposition IS NULL OR @disposition = ''
  SELECT @disposition = 'ignored'

--- DROP TABLE  GEM_APMGenericMsgs
 IF NOT EXISTS (SELECT * FROM sysobjects WHERE type ='U' AND name = 'GEM_APMGenericMsgs')
      CREATE TABLE GEM_APMGenericMsgs
        (
		class  NVARCHAR(128) NULL,
		instanceid NVARCHAR(128) NULL  ,
		instancename NVARCHAR(128) NULL  ,
		probetype NVARCHAR(128) NULL ,
		probeid NVARCHAR(255) NULL ,
		probename NVARCHAR(128) NULL  ,
		probeargs NVARCHAR(128) NULL, 
		severity NVARCHAR(128) NULL, 
		probevalue NVARCHAR(128) NULL, 
		probecondition NVARCHAR(128) NULL, 
		msg NVARCHAR(255) NULL,
		eehost NVARCHAR(128) NULL,
		hostos INT,
		tcphostname NVARCHAR(128) NULL,
		tmr NVARCHAR(128) NULL,
                mgedsysname NVARCHAR(128) NULL,
                data1 NVARCHAR(128) NULL, 
                data2 NVARCHAR(128) NULL, 
                data3 NVARCHAR(128) NULL, 
                data4 NVARCHAR(128) NULL, 
	        disposition NVARCHAR(128) NULL,
                eventtime int NULL,
		time DATETIME NULL)

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'U' AND name = 'GEM_Options')
  IF EXISTS (SELECT * FROM GEM_Options WHERE _Option = 'trace events' AND _Value = 'yes') BEGIN
    INSERT INTO GEM_APMGenericMsgs (class, instanceid, instancename, probetype, probeid, probename, probeargs, severity, probevalue, probecondition, msg, eehost, hostos, tcphostname, tmr, mgedsysname, data1, data2, data3, data4, disposition, eventtime, time )
      VALUES (	@tbsmclass, 	
	  @instanceid, 
	  @instancename, 
	  @probetype, 
	  @probeid, 
	  @probename, 
	  @probeargs, 
	  @severity, 
	  @probevalue, 
	  @probecondition, 
	  @msg, 
	  @eehost, 
	  @hostos, 
	  @tcphostname, 
	  @tmr,
          @hostnameslot,
          @data1,
          @data2,
          @data3,
          @data4,
	  @disposition, 
          @eventtime,
	GETDATE()
		)
END 

-- commit transaction
IF @tcount = 0 
  COMMIT TRAN gemsp_processAPMGenericMsg

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

