SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

/****** Object:  Stored PROCEDURE dbo.gemsp_processAPMHeartBeatMsg    Script Date: 5/12/00 10:32:15 AM ******/
IF EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[dbo].[gemsp_processAPMHeartBeatMsg]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[gemsp_processAPMHeartBeatMsg]
GO



CREATE PROCEDURE gemsp_processAPMHeartBeatMsg
		@class  NVARCHAR(128)='',
		@hostname_slot  NVARCHAR(128)='',
		@orig_origin NVARCHAR(255)='',
		@orig_suborigin NVARCHAR(255)='',
		@source NVARCHAR(128)='',
		@subsource NVARCHAR(128)='',
		@dispname NVARCHAR(128)='',
		@mgednode NVARCHAR(128)='',
		@hbinterval NVARCHAR(128)='',
		@data1 NVARCHAR(128)='',
		@data2 NVARCHAR(128)='',
		@data3 NVARCHAR(128)='',
		@data4 NVARCHAR(128)='',
		@endptoid NVARCHAR(128)='',
		@oldorigin NVARCHAR(255)='',
		@oldsuborigin NVARCHAR(255)='',
		@oldsource NVARCHAR(128)='',
		@oldsubsource NVARCHAR(128)='',
		@appstatus NVARCHAR(128)='',
		@adapterhost NVARCHAR(128)='',
		@eehost NVARCHAR(128)='',
                @ostype INT=-1,
                @endpointlabel NVARCHAR(128)='',
                @endpointtmr NVARCHAR(128)='',
                @endpointtcphostname NVARCHAR(128)='',
                @eventtime int=0
                
 AS

RAISERROR('gemsp_processAPMHeartBeatMsg: @hostname_slot=%s, @orig_origin=%s,
	  @orig_suborigin=%s, @source=%s, @subsource=%s, @dispname=%s, @mgednode=%s,
	  @hbinterval=%s, @data1=%s, @data2=%s, @data3=%s, @data4=%s, @endptoid=%s, 
	  @appstatus=%s, @adapterhost=%s, @eehost=%s, @ostype=%d, @endpointlabel=%s, 
	  @endpointtmr=%s, @endpointtcphostname=%s', 0, 1, @hostname_slot, @orig_origin, 
	  @orig_suborigin, @source, @subsource, @dispname, @mgednode, @hbinterval, @data1, 
	  @data2, @data3, @data4, @endptoid, @appstatus, @adapterhost, @eehost, @ostype, 
	  @endpointlabel, @endpointtmr, @endpointtcphostname)

-- Standard transaction logic
DECLARE @tcount INT
SELECT @tcount = @@TRANCOUNT
IF @tcount = 0
  BEGIN TRAN gemsp_processAPMHeartBeatMsg
ELSE
  SAVE TRAN gemsp_processAPMHeartBeatMsg

DECLARE @msg NVARCHAR(128)
SELECT @msg = 'no further details available'
DECLARE @cmd NVARCHAR(1024)   -- jpf 
DECLARE @disposition NVARCHAR(128)
SELECT @disposition = 'ignored'

DECLARE @productName NVARCHAR(128)
DECLARE @version NVARCHAR(128)
DECLARE @origin  NVARCHAR(255)
DECLARE @suborigin NVARCHAR(255)

DECLARE @comptype NVARCHAR(32)

DECLARE @hostname NVARCHAR(128)
DECLARE @temp NVARCHAR(255)    -- jpf
DECLARE @deleteproc NVARCHAR(16)

IF @hostname_slot IS NOT NULL
  SELECT @hostname = @hostname_slot
ELSE
  SELECT @hostname = @data1



DECLARE @time DATETIME
declare @timetemp nvarchar(64)

--- now prepare the timestamp from the one that was passed in 
set @timetemp = cast(@eventtime as nvarchar)
IF @eventtime is null or @eventtime=0 SELECT @time = CURRENT_TIMESTAMP  
ELSE exec cl_getLocalTime @time=@timetemp, @tout=@time output




DECLARE @cid ClassID
DECLARE @oid ObjID

DECLARE @updateSlots TINYINT
DECLARE @updateLookup TINYINT    --- jpf
DECLARE @updateLOB TINYINT       --- jpf
DECLARE @isaNewInstance TINYINT  --- jpf


SET @updateSlots = 0
SET @updateLOB = 0       --- jpf
SET @updateLookup = 0    --- jpf
SET @isaNewInstance = 0  --- jpf
SELECT @cmd ='' ---jpf

DECLARE @print_string NVARCHAR(1024)

-- generate search arguments based ON heartbeat slots

EXEC gemsp_getHBid @subsource, @orig_origin, @orig_suborigin, @hostname,
                   @productName OUTPUT, @version OUTPUT, @origin OUTPUT, @suborigin OUTPUT

-- look FOR an existing instance of this software component

EXEC gemsp_print 'performing first lookup'
EXEC gemsp_HBid_to_IID @productName, @version, @origin, @suborigin,
                       @cid OUTPUT, @oid OUTPUT
SET @print_string = 'first lookup returned oid=' + CAST(@oid AS NVARCHAR(10))
EXEC gemsp_print @print_string

IF (@oid IS NULL) AND (@oldsubsource IS NOT NULL OR @oldorigin IS NOT NULL OR @oldsuborigin IS NOT NULL)
BEGIN
  -- SAVE the new massaged origin/suborigin slots
  DECLARE @new_origin  NVARCHAR(255)
  DECLARE @new_suborigin NVARCHAR(255)
  SET @new_origin = @origin		-- jcp 64746
  SET @new_suborigin = @suborigin	-- jcp 64746

  -- generate search arguments based ON "old" heartbeat slots

  EXEC gemsp_getHBid @oldsubsource, @oldorigin, @oldsuborigin, @hostname,
                     @productName OUTPUT, @version OUTPUT, @origin OUTPUT, @suborigin OUTPUT

  -- look FOR an existing instance of this software component

  EXEC gemsp_print 'performing second lookup'
  EXEC gemsp_HBid_to_IID @productName, @version, @origin, @suborigin,
                         @cid OUTPUT, @oid OUTPUT
  SET @print_string = 'second lookup returned oid=' + CAST(@oid AS NVARCHAR(10))
  EXEC gemsp_print @print_string

  IF @oid IS NOT NULL BEGIN
    --- matched an instance whose origin, suborigin, source, AND/OR subsource
    ---  fields are being changed
    SET @updateSlots = 1
    SET @updateLookup = 1  --- jpf
    SET @updateLOB = 1  --- jpf
    --- start to build the UPDATE command note that this IS the first part of the 
    --- command built AND that the actual sql command built earlier will need to 
    --- be prefixed to this line ... jpf 

    SELECT @cmd = @cmd + ', _Origin = ''' + @orig_origin + ''', _Sub_origin = ''' + @orig_suborigin + ''''
    --- jpf this NEXT piece of code could be moved
    --- being moved to the END EXEC gemsp_updateLookup @cid, @oid, @new_origin, @new_suborigin, -- jcp 64700
    ---                 @endpointlabel, @endpointtmr, @endpointtcphostname, @hostname_slot, @data1
  END

  -- restore the new origin/suborigin slots, the old ones are no good to us
  SET @origin = @new_origin		-- jcp 64746
  SET @suborigin = @new_suborigin	-- jcp 64746

END

SET @print_string = 'cid=' + @cid + ', oid=' + CAST(@oid AS NVARCHAR(6))
EXEC gemsp_print @print_string

IF @cid IS NULL
  SELECT @cid = cid FROM GEMLookupCID WHERE prodname = @productName AND version = @version 
                                      AND enabled = 1 AND comptype <> 'dm' AND comptype <> 'gen'

IF @dispname IS NULL AND @cid IS NOT NULL BEGIN
   SELECT @dispname = label FROM obj_class WHERE cid = @cid
   IF @hostname IS NOT NULL
     IF @hostname <> ''
      SET @dispname = @dispname + '@' + @hostname
END

IF (@oid IS NOT NULL) BEGIN
  -- we found an existing instance FOR this software component
  DECLARE @cname NVARCHAR(128)
  DECLARE @attrTable NVARCHAR(64)

  --- start to build the UPDATE sql statement 
  SELECT @cname = cname FROM Meta.dbo.obj_class_table WHERE cid = @cid
  SELECT @attrTable = @cname + '_C'
  --- prefix the command ON just IN CASE part of the command was already built   jpf 
  SELECT @cmd = 'UPDATE ' + @attrTable + ' SET _LastHbTimestamp = ''' + CAST(GETDATE() AS NVARCHAR(128)) + ''' ' + @cmd ---jpf 
  SET @updateSlots = 1 

  IF @appstatus = 'GONE' BEGIN
    SET @updateSlots = 0
    SET @updateLOB = 0
    SET @updateLookup = 0 
    SELECT @disposition = 'deleted ' + @cid + ' oid ' + CAST(@oid AS NVARCHAR(10))
  END
  ELSE BEGIN
    SELECT @disposition = 'refreshed ' + @cid + ' oid ' + CAST(@oid AS NVARCHAR(10))

    DECLARE @previousDispname NVARCHAR(128)
    DECLARE @currentName NVARCHAR(128)


  -- has the instance's display name changed ON the GEM screen?
    EXEC gemsp_getAttribute @cid, @oid, 'name', @currentName OUTPUT
    EXEC gemsp_getAttribute @cid, @oid, '_PreviousDisplayName', @previousDispname OUTPUT

    -- has the instance's display name changed ON the GEM screen?

    IF @dispname <> @previousDispname BEGIN
      SELECT @cmd = @cmd + ', _PreviousDisplayName = ''' + @dispname + ''''

      -- new GEM name only takes effect IF the instance name hasn't been changed ON the TBSM console

      IF @previousDispname = @currentName
        SELECT @cmd = @cmd + ', name = ''' + @dispname + ''''
    END

    IF @comptype = 'os/390' BEGIN
        -- now check whether the hostname needs to be updated
      IF (@hostname IS NOT NULL) BEGIN
      -- IF a value was passed IN ON this event THEN GO check IF the database needs to 
      --   be updated
         EXEC gemsp_getAttribute @cid, @oid, '_NetviewDomainName', @temp OUTPUT
        IF (@temp IS NULL) OR (@hostname <> @temp) BEGIN
         SET @updateSlots = 1 
         SET @updateLOB = 1 
         SET @updateLookup = 1 
         SELECT @cmd = @cmd + ', _NetviewDomainName = ''' + @hostname + ''''

        END

      END

    END
   ELSE IF @comptype = 'gem' BEGIN
    -- now check whether the hostname needs to be updated
      IF (@hostname IS NOT NULL) BEGIN
      -- IF a value was passed IN ON this event THEN GO check IF the database needs to 
      --   be updated
         EXEC gemsp_getAttribute @cid, @oid, '_MgedSystemName', @temp OUTPUT
        IF (@temp IS NULL) OR (@hostname <> @temp) BEGIN
         SET @updateSlots = 1 
         SET @updateLOB = 1 
         SET @updateLookup = 1 
         SELECT @cmd = @cmd + ', _MgedSystemName = ''' + @hostname + ''''

         END

      END
    END 

  -- now check whether the oid needs to be updated
    IF (@endptoid IS NOT NULL)  BEGIN
      -- IF a value was passed IN ON this event THEN GO check IF the database needs to 
      --   be updated.  IF the Oid field changes THEN we can assume that the 
      ---  label AND tmr fields have changed.  THis code assumes that the opposite IS true
      ---  AS well.
      EXEC gemsp_getAttribute @cid, @oid, '_TmeEndpointOid', @temp OUTPUT

      IF (@temp IS NULL) OR (@endptoid <> @temp) BEGIN
         SET @updateSlots = 1 
         SET @updateLOB = 1 
         SET @updateLookup = 1 
         --- UPDATE the oid, label AND tmr
         SELECT @cmd = @cmd + ', _TmeEndpointOid = ''' + @endptoid + '''' + ', _EPTTMR = ''' + @endpointtmr + '''' + ', _EPTLabel = ''' + @endpointlabel + ''''
          
      END

    END



  -- now handle the data slots
    -- now check whether the data1 needs to be updated
    IF (@data1 IS NOT NULL) BEGIN
      -- IF a value was passed IN ON this event THEN GO check IF the database needs to 
      --   be updated
      EXEC gemsp_getAttribute @cid, @oid, '_Data1', @temp OUTPUT
      IF (@temp IS NULL) OR (@data1 <> @temp) BEGIN
         SET @updateSlots = 1 
         SET @updateLOB = 1 
         SELECT @cmd = @cmd + ', _Data1 = ''' + @data1+ ''''         
      END

    END

    IF (@data2 IS NOT NULL) BEGIN
      -- IF a value was passed IN ON this event THEN GO check IF the database needs to 
      --   be updated
      EXEC gemsp_getAttribute @cid, @oid, '_Data2', @temp OUTPUT
      IF (@temp IS NULL) OR (@data2 <> @temp) BEGIN
         SET @updateSlots = 1 
         SET @updateLOB = 1 
         SELECT @cmd = @cmd + ', _Data2 = ''' + @data2+ ''''         
      END

    END
    IF (@data3 IS NOT NULL) BEGIN
      -- IF a value was passed IN ON this event THEN GO check IF the database needs to 
      --   be updated
      EXEC gemsp_getAttribute @cid, @oid, '_Data3', @temp OUTPUT
      IF (@temp IS NULL) OR (@data3 <> @temp) BEGIN
         SET @updateLOB = 1 
         SET @updateSlots = 1 
         SELECT @cmd = @cmd + ', _Data3 = ''' + @data3+ ''''         
      END

    END
    IF (@data4 IS NOT NULL) BEGIN
      -- IF a value was passed IN ON this event THEN GO check IF the database needs to 
      --   be updated
      EXEC gemsp_getAttribute @cid, @oid, '_Data4', @temp OUTPUT
      IF (@temp IS NULL) OR (@data4 <> @temp) BEGIN
         SET @updateLOB = 1 
         SET @updateSlots = 1 
         SELECT @cmd = @cmd + ', _Data4 = ''' + @data4+ ''''         
      END

    END

    --- finally check IF the tcpiphostname has changed IF so, the instance has 
    --- moved so we need to drive the GONE processing AND THEN recreate the instance
      EXEC gemsp_getAttribute @cid, @oid, '_TCPHost', @temp OUTPUT

      IF ((@temp IS NOT NULL) AND (@endpointtcphostname IS NULL)) OR 
            ((@temp IS NULL) AND (@endpointtcphostname IS NOT NULL)) OR 
               (@endpointtcphostname <> @temp) 
      BEGIN

        -- reset these fields
         SET @updateLOB = 0  
         SET @updateSlots = 0  
        -- send the GONE FOR this oid
         EXEC gemsp_print 'deleting oid since the tcpiphostname changed'
         SELECT @deleteproc = 'delete_' + @cid
         EXEC @deleteproc @oid
        -- now make the rest of the code process this heartbeat AS a first time heartbeat
         SET @oid = NULL

      END

  END

  SELECT @cmd = @cmd + ' WHERE id = ' + CAST(@oid AS NVARCHAR(10))


  IF @updateSlots = 1 BEGIN
    SET @print_string = ' updating slots ... cmd="' + @cmd + '"'
    EXEC gemsp_print @print_string
    EXEC(@cmd)
  END 

  IF @appstatus = 'GONE' BEGIN
    SELECT @deleteproc = 'delete_' + @cid
    EXEC @deleteproc @oid
    SET @oid = NULL
  END
  ELSE BEGIN
    -- IF there's an overdue exception FOR this heartbeat, DELETE it
    
   SELECT @disposition = @disposition + ', removed overdue heartbeat alert IF EXISTS'

   EXEC asisp_createEXCP @name='APM_HEARTBEAT', @parent_cid=@cid, @parent_id=@oid, @DATE=@time,
                         @TIME=@time, @EXCP_NAME='APM_HEARTBEAT', @EXCP_CD='OK', @AlertState=-1, @Priority=-1
  END
END


-- We may NOT have an instance at this point because this IS the first heartbeat
--   FOR this component OR the tcpiphost changed causing a reprocessing of the 
--   heartbeat after a DELETE was called

IF ((@oid IS NULL) OR (@oid = 0)) AND (@appstatus <> 'GONE') BEGIN
  -- no existing instance FOR this software component
  IF @cid IS NOT NULL
  BEGIN
    DECLARE @manufacturer NVARCHAR(128)
    SELECT @manufacturer = manufacturer, @comptype = comptype FROM GEMLookupCID 
           WHERE prodname = @productName AND version = @version

    -- find/CREATE parent object FOR this software component IN the physical tree

    DECLARE @parentid ObjID
    DECLARE @parentclass ClassID

    EXEC gemsp_get_parent @cid, @endpointtcphostname, @hostname_slot, @ostype, @eehost, 
                          @parentid OUTPUT, @parentclass OUTPUT, @msg OUTPUT
    IF @parentid > 0
    BEGIN

      IF @hbinterval IS NULL SET @hbinterval = '0'
      DECLARE @hbint INT
      SELECT @hbint = CAST(@hbinterval AS INT)

      DECLARE @timestamp DATETIME
      SELECT @timestamp = GETDATE()

      DECLARE @createproc NVARCHAR(16)
      SELECT @createproc = 'asisp_create' + @cid

      IF @comptype = 'gem' BEGIN
        EXEC @oid = @createproc @dispname,
                                 @parentclass,
                                 @parentid,
                                 @data1,
                                 @data2,
                                 @data3,
                                 @data4,
                                 @endpointlabel,
                                 @hostname,
                                 @origin,
                                 @dispname,
                                 @source,
                                 @suborigin,
                                 @subsource,
                                 @endptoid,
                                 @eehost,
                                 @endpointtmr,
                                 @hbint,
                                 @timestamp,
                                 @manufacturer,
                                 @productName,
                                 @endpointtcphostname,
                                 @version
      END
      ELSE IF @comptype = 'os/390' BEGIN
        EXEC @oid = @createproc @dispname,
                                 @parentclass,
                                 @parentid,
                                 @data1,
                                 @data2,
                                 @data3,
                                 @data4,
                                 @endpointlabel,
                                 @hostname_slot,
                                 @origin,
                                 @dispname,
                                 @source,
                                 @suborigin,
                                 @subsource,
                                 @endptoid,
                                 @eehost,
                                 @endpointtmr,
                                 @hbint,
                                 @timestamp,
                                 @manufacturer,
                                 @productName,
                                 @endpointtcphostname,
                                 @version
      END

      IF @oid > 0 BEGIN
        SET @updateLOB = 1    --- jpf
        SET @updateLookup = 1 --- jpf
        SET @disposition = 'created ' + @cid + ' oid ' + CAST(@oid AS NVARCHAR(10))
        EXEC gemsp_print @disposition
      END
      ELSE BEGIN
        SET @oid = NULL
        RAISERROR('TBSM2007E: %s could NOT CREATE object', 0, 1, @createproc) with log
        SET @disposition = 'TBSM2007E: ' + @createproc + ' could NOT CREATE object'
      END

    END -- found/created the parent container object
    ELSE BEGIN
      SET @oid = NULL
      RAISERROR('TBSM2008E: error creating %s object: %s', 0, 1, @cid, @msg) with log
      SET @disposition = 'TBSM2008E: error creating ' + @cid + ' object: ' + @msg
    END
  END -- got a cid
  ELSE BEGIN
    SET @oid = NULL
    RAISERROR('TBSM3001W: Product %s Version %s IS NOT defined', 0, 1, @productName, @version)
    SET @disposition = 'TBSM3001W: Product ' + @productName + ' Version ' + @version + ' IS NOT defined'
  END
END



IF @oid IS NOT NULL
   BEGIN

     IF @updateLookup = 1 BEGIN   --- jpf 
          EXEC gemsp_updateLookup @cid, @oid, @origin, @suborigin, 
                    @endpointlabel, @endpointtmr, @endpointtcphostname, @hostname_slot, @data1
     END


     IF @updateLOB = 1 BEGIN
      DECLARE @lob_disp NVARCHAR(128)
      SET @lob_disp = NULL
      EXEC gemsp_LOBs @cid, @oid, @lob_disp OUTPUT -- put the instance IN a line of business
      IF @lob_disp IS NOT NULL SET @disposition = @disposition + ', ' + @lob_disp
     END
   END 

IF NOT EXISTS (SELECT * FROM sysobjects WHERE type = 'U' AND name = 'GEM_APMHBMsgs')
  CREATE TABLE GEM_APMHBMsgs(
    class  NVARCHAR(128) NULL,
    hostname  NVARCHAR(128) NULL,
    origin NVARCHAR(255) NULL,
    suborigin NVARCHAR(255) NULL,
    source NVARCHAR(128) NULL,
    subsource NVARCHAR(128) NULL,
    dispname NVARCHAR(128) NULL,
    mgednode NVARCHAR(128) NULL,
    hbinterval NVARCHAR(128) NULL,
    data1 NVARCHAR(128) NULL,
    data2 NVARCHAR(128) NULL,
    data3 NVARCHAR(128) NULL,
    data4 NVARCHAR(128) NULL,
    endptoid NVARCHAR(128) NULL,
    oldorigin NVARCHAR(255) NULL,
    oldsuborigin NVARCHAR(255) NULL,
    oldsource NVARCHAR(128) NULL,
    oldsubsource NVARCHAR(128) NULL,
    appstatus NVARCHAR(128) NULL,
    adapterhostname NVARCHAR(128) NULL,
    eehost NVARCHAR(128) NULL,
    ostype INT NULL,
    endpointlabel NVARCHAR(128) NULL,
    endpointtmr NVARCHAR(128) NULL,
    endpointtcphostname NVARCHAR(128) NULL,
    disposition NVARCHAR(128) NULL,
    eventtime int NULL,
    time DATETIME NULL)

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'U' AND name = 'GEM_Options')
  IF EXISTS (SELECT * FROM GEM_Options WHERE _Option = 'trace events' AND _Value = 'yes') BEGIN
    INSERT INTO GEM_APMHBMsgs (class, hostname, origin, suborigin, source, subsource, dispname, mgednode, hbinterval, 
                               data1, data2, data3, data4, endptoid, oldorigin, oldsuborigin,oldsource, oldsubsource, 
                               appstatus, adapterhostname, eehost, ostype, endpointlabel, endpointtmr, endpointtcphostname, 
                               disposition, eventtime, time)
  
      VALUES (@class, 
	@hostname_slot ,
	@orig_origin,
	@orig_suborigin,
	@source,
	@subsource,
	@dispname,
	@mgednode,
	@hbinterval,
	@data1,
	@data2,
	@data3,
	@data4,
	@endptoid,
	@oldorigin,
	@oldsuborigin,
	@oldsource,
	@oldsubsource,
	@appstatus,
	@adapterhost,
        @eehost,
        @ostype,
        @endpointlabel,
        @endpointtmr,
        @endpointtcphostname,
        @disposition,
        @eventtime,
	GETDATE()
		)
  END

-- commit transaction
IF @tcount = 0 
  COMMIT TRAN gemsp_processAPMHeartBeatMsg

GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

