SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

/****** Object:  Stored PROCEDURE dbo.gemsp_processAPMThresholdMsg    Script Date: 8/2/00 8:36:36 AM ******/
IF EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[dbo].[gemsp_processAPMThresholdMsg]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[gemsp_processAPMThresholdMsg]
GO



CREATE PROCEDURE [gemsp_processAPMThresholdMsg] 
		@class  NVARCHAR(128)='',
		@hostname_slot  NVARCHAR(128)='',
		@origin NVARCHAR(255)='',
		@suborigin NVARCHAR(255)='',
		@source NVARCHAR(128)='',
		@subsource NVARCHAR(128)='',
		@adapterhost  NVARCHAR(128)='' ,
		@probeid NVARCHAR(128)=''  ,
		@probeargs NVARCHAR(128)='', 
		@probevalue NVARCHAR(255)='', 
		@probelabel NVARCHAR(128)='', 
		@severity NVARCHAR(128)='', 
		@mgednode NVARCHAR(128)='',
                @eehost NVARCHAR(128)='',
                @ostype INT=-1,
                @endpointtcphostname NVARCHAR(128)='',
                @endpointtmr NVARCHAR(128)='',
                @eventtime int=0
	
AS

RAISERROR('gemsp_processAPMThresholdMsg: @class=%s, @hostname_slot=%s, @origin=%s, @suborigin=%s,
	  @source=%s, @subsource=%s, @adapterhost=%s, @probeid=%s, @probeargs=%s, @probevalue=%s,
	  @probelabel=%s, @severity=%s, @mgednode=%s, @eehost=%s, @ostype=%d, 
	  @endpointtcphostname=%s, @endpointtmr=%s', 0, 1, @class, @hostname_slot, @origin, 
	  @suborigin, @source, @subsource, @adapterhost, @probeid, @probeargs, @probevalue, 
	  @probelabel, @severity, @mgednode, @eehost, @ostype, @endpointtcphostname,
	  @endpointtmr)

-- Standard transaction logic
DECLARE @tcount INT
SELECT @tcount = @@TRANCOUNT
IF @tcount = 0
  BEGIN TRAN gemsp_processAPMThresholdMsg
ELSE
  SAVE TRAN gemsp_processAPMThresholdMsg

DECLARE @print_string NVARCHAR(1024)

EXEC gemsp_print 'gemsp_processAPMThresholdMsg begins...'

IF @class = 'APM_SYS_MONITOR' BEGIN
EXEC gemsp_print 'System Monitor Event Received ... NOT supported.'
goto getout
END 



DECLARE @time DATETIME
declare @timetemp nvarchar(64)

--- now prepare the timestamp from the one that was passed in 
set @timetemp = cast(@eventtime as nvarchar)
IF @eventtime is null or @eventtime=0 SELECT @time = CURRENT_TIMESTAMP  
ELSE exec cl_getLocalTime @time=@timetemp, @tout=@time output




SET @print_string = 'ostype=' + CAST(@ostype AS NVARCHAR)
EXEC gemsp_print @print_string
SET @print_string = 'endpointtmr=' + @endpointtmr
EXEC gemsp_print @print_string
SET @print_string = 'endpointtcphostname=' + @endpointtcphostname
EXEC gemsp_print @print_string



-- DECLARE @eehost NVARCHAR(128)
-- SET @eehost = 'ntmrs02.rtp.lab.tivoli.com'

DECLARE @msg NVARCHAR(128)
SELECT @msg = 'no further details available'

DECLARE @comptype NVARCHAR(32)

DECLARE @disposition NVARCHAR(128)
SELECT @disposition = 'ignored'

IF @probeid IS NULL OR @probeid = ''
  SET @probeid = @probelabel

IF @probeid IS NULL OR @probeid = ''
  EXEC gemsp_print 'This event doesn''t seem to be a REAL threshold. We''ll ignore it'

ELSE BEGIN -- this event has a probeid so it IS a REAL threshold

DECLARE @hostname NVARCHAR(128)

IF @adapterhost IS NOT NULL
  IF @adapterhost <> ''
    SET @hostname = @adapterhost

IF @hostname IS NULL
  IF @hostname_slot IS NOT NULL
    IF @hostname_slot <> ''
      SET @hostname = @hostname_slot

IF @endpointtcphostname IS NULL OR @endpointtcphostname  = '' 
  SET   @endpointtcphostname =  @hostname

DECLARE @productName NVARCHAR(64)
DECLARE @version NVARCHAR(64)
DECLARE @manufacturer NVARCHAR(64)

DECLARE @cid ClassID
DECLARE @oid ObjID

SET @print_string = 'gemsp_Threshold_to_IID input: @subsource=' + @subsource + ', origin=' + @origin + 
      ', suborigin=' + @suborigin + ', hostname_slot=' + @hostname_slot + ', adapterhost=' + @adapterhost
EXEC gemsp_print @print_string

-- sp_helptext gemsp_Threshold_to_IID

CREATE TABLE #thresholdinstances(
	cid	ClassID,
	iid	ObjID)

EXEC gemsp_Threshold_to_IID @origin, @suborigin, @subsource, @hostname_slot, 
                            @endpointtmr, @endpointtcphostname, @hostname_slot, @adapterhost

DECLARE @count INT
SELECT @count = COUNT(*) FROM #thresholdinstances
SET @print_string = CAST(@count AS NVARCHAR(4)) + ' threshold/instance combinations returned by gemsp_Threshold_to_IID'
EXEC gemsp_print @print_string

IF @count = 0 BEGIN
  -- Some DM monitors cannot be associated with a software component based 
  -- only the slots IN the threshold event. The subsource IN the event will 
  -- contain the DM Profile name which we can try to associate with a CID 
  -- using another TABLE the customer sets up.  We might even CREATE
  -- an instance of the CID IF we don't find an instance AND we don't expect
  -- a heartbeat FOR the software component.

  SELECT @cid = cid, @productName = prodname, @version = version, @manufacturer = manufacturer FROM GEMLookupCID 
         WHERE comptype = 'dm' AND cid IN (SELECT CID FROM GEM_DMtoCID WHERE profileName = @subsource)

  IF @cid IS NOT NULL BEGIN
    SET @comptype = 'dm'
    SET @print_string = 'GEM_DMtoCID maps ' + @subsource + ' to ' + @cid
    EXEC gemsp_print @print_string

    DECLARE @parentid ObjID
    DECLARE @parentclass ClassID

    IF @hostname_slot IS NULL OR @hostname_slot =''  BEGIN 
      EXEC gemsp_print 'This event cannot be used to CREATE a DM instance. Hostname slot IS NOT SET.'
    END 
    ELSE BEGIN


      -- find OR find/CREATE the parent container

      EXEC gemsp_get_parent @cid, @endpointtcphostname, '', @ostype, @eehost, 
                          @parentid OUTPUT, @parentclass OUTPUT, @msg OUTPUT

      /* we can CREATE the instance since we don't expect a heartbeat FROM normal instrumentation */

      IF @parentid > 0 BEGIN
        DECLARE @timestamp DATETIME
        SELECT @timestamp = GETDATE()

        DECLARE @createproc NVARCHAR(16)
        SELECT @createproc = 'asisp_create' + @cid

        EXEC @oid = @createproc @hostname_slot, 
                                 @parentclass,
                                 @parentid,
                                 @hostname,
                                 @origin,
                                 @source,
                                 @suborigin,
                                 @subsource,
                                 @eehost,
                                 @endpointtmr,
                                 0,          -- no heartbeat interval
                                 @timestamp,
                                 @manufacturer,
                                 @productName,
                                 @endpointtcphostname,
                                 @version

        IF @oid > 0 BEGIN 
          SET @disposition = 'created cid ' + @cid + ' oid ' + CAST(@oid AS NVARCHAR(10))
          EXEC gemsp_print @disposition

          DECLARE @lob_disp NVARCHAR(128)
          SET @lob_disp = NULL
          EXEC gemsp_LOBs @cid, @oid, @lob_disp OUTPUT -- put the instance IN a line of business
          IF @lob_disp IS NOT NULL SET @disposition = @disposition + ', ' + @lob_disp

          /* we want to cache the new oid so we can pick it up quickly NEXT time the threshold comes IN. */
          DECLARE @new_origin NVARCHAR(255)
          DECLARE @new_suborigin NVARCHAR(255)
          SET @new_origin = '1=' + @origin
          SET @new_suborigin = '0=EPObjName=' + @hostname
  
          EXEC gemsp_updateLookup @cid, @oid, @origin, @suborigin, 
                                NULL, @endpointtmr, @endpointtcphostname, @hostname_slot, NULL

          EXEC gemsp_Threshold_to_IID @origin, @suborigin, @subsource, @hostname_slot, 
                                    @endpointtmr, @endpointtcphostname, @hostname_slot, @adapterhost

          SELECT @count = COUNT(*) FROM #thresholdinstances

        END -- created the instance
        ELSE BEGIN
          RAISERROR('TBSM2007E: %s could NOT CREATE object', 0, 1, @createproc) with log
          SET @disposition = 'TBSM2007E: ' + @createproc + ' could NOT CREATE object'
        END
      END /* able to CREATE a new instance */
     ELSE BEGIN
      RAISERROR('TBSM2008E: error creating %s object: %s', 0, 1, @cid, @msg) with log
      SET @disposition = 'TBSM2008E: error creating ' + @cid + ' object: ' + @msg
      END

    END -- got the DM profile to map to a CID

   END -- hostname slot IS NOT SET 
  ELSE BEGIN  -- IF cid IS NULL 
    RAISERROR('TBSM3002W: %s IS NOT associated with a cid IN GEM_DMtoCID', 0, 1, @subsource)
    SET @disposition = 'TBSM3002W: ' + @subsource + ' IS NOT associated with a cid IN GEM_DMtoCID'
  END
END -- see IF the event can be associated with a CID via the DM profile name

IF @count > 0 BEGIN
  DECLARE @probename NVARCHAR(255)
  SET @probename = @probelabel
  IF @probeargs IS NOT NULL
    IF @probeargs <> '' SET @probename = @probename + ' ' + @probeargs

  /* the staged event loader will clog up IF we try to CREATE an exception with a NULL value
     FOR the EXCP_CD - S/390 thresholds are like this so we have to make the probevalue more
     pleasing */

  IF @probevalue IS NULL
    SET @probevalue = ''

  -- getExceptionType will CREATE the exception object FOR this software component IF necessary
  SELECT @cid = cid FROM #thresholdinstances
  EXEC asisp_getExceptionType @cid, @cid, @probename, 1, 5, NULL, 'GEM', 'Dynamically defined' 

  IF @disposition = 'ignored'
    SET @disposition = 'processed cid ' + @cid + ': '
  ELSE
    SET @disposition = @disposition + ', processed cid ' + @cid + ': '

  -- process each instance 
  DECLARE iCursor CURSOR FOR 
    SELECT cid, iid FROM #thresholdinstances
  OPEN iCursor
  FETCH NEXT FROM iCursor INTO @cid, @oid
  WHILE @@FETCH_STATUS = 0 BEGIN
    SET @print_string = 'top of loop, cid=' + @cid + ', oid=' + CAST(@oid AS NVARCHAR(6))
    EXEC gemsp_print @print_string
    SET @disposition = @disposition + CAST(@oid AS NVARCHAR(10)) + ' '

    DECLARE @currState INT
    DECLARE @currPriority INT

    DECLARE @stateMonitor INT
    SET @stateMonitor = 0
    IF @probeid like '[Ss][Tt][Aa][Tt][Ee]' OR @probelabel like '[Ss][Tt][Aa][Tt][Ee]' 
      SET @stateMonitor = 1

    IF @stateMonitor = 0 BEGIN
      -- remove existing exception FOR this threshold IF necessary
    
      

      EXEC asisp_createEXCP @name=@probename, @parent_cid=@cid, @parent_id=@oid, @DATE=@time,
                            @TIME=@time, @EXCP_NAME=@probename, @EXCP_CD='OK', @AlertState=-1, @Priority=-1      
    END

    -- CREATE new exception FOR the threshold, reflecting the current severity

    SELECT @currState=AlertState, @currPriority=Priority FROM GEMSeverities WHERE Severity = @severity
    IF @currState IS NULL
      SELECT @currState=AlertState, @currPriority=Priority FROM GEMSeverities WHERE Severity = 'INFORMATIONAL'

    -- IF this IS the state monitor, we'll force it to always be propagated.  It should only have a Red OR Green
    -- alert state.  IF it's Red, it overrides all other thresholds.  IF it's Green, thresholds will override it.



    IF @stateMonitor = 0 BEGIN
      EXEC gemsp_print 'setting current exception'
      EXEC asisp_createEXCP @name=@probename, @parent_cid=@cid, @parent_id=@oid, @DATE=@time, @TIME=@time, 
                            @EXCP_NAME=@probename, @EXCP_CD=@probevalue, 
                            @AlertState=@currState, @Priority=@currPriority
    END
    ELSE BEGIN
      EXEC gemsp_print 'creating exception FOR state monitor'
      SET @currPriority = 1 -- "critical priority" IS always propagated up
      EXEC asisp_createMESG
              @name=@probename,
              @parent_cid=@cid,
              @parent_id=@oid,
              @DATE=@time,
              @TIME=@time,
              @MESSAGE=@probename,
              @REASON_CD=@probevalue,
              @AlertState=@currState,
              @Priority=@currPriority
    END

    FETCH NEXT FROM iCursor INTO @cid, @oid
  END
  CLOSE iCursor
  DEALLOCATE iCursor
END
ELSE IF (@comptype <> 'dm') BEGIN
  RAISERROR('TBSM3003W: Received threshold FOR an instance we don''t have a heartbeat FOR: subsource=%s, origin=%s, suborigin=%s, hostname=%s', 
            0, 1, @subsource, @origin, @suborigin, @hostname_slot)
  SET @disposition = 'TBSM3003W: Received threshold FOR an instance we don''t have a heartbeat FOR'
END

END -- this event has a probeid so it IS a REAL threshold

IF NOT EXISTS (SELECT * FROM sysobjects WHERE type ='U' AND name = 'GEM_APMTHRMsgs')
   CREATE TABLE GEM_APMTHRMsgs
          (class  NVARCHAR(128) NULL,
           hostname  NVARCHAR(128) NULL,
           origin NVARCHAR(255) NULL,
           suborigin NVARCHAR(255) NULL,
           source NVARCHAR(128) NULL,
           subsource NVARCHAR(128) NULL,
           adapterhostname  NVARCHAR(128) NULL,
           probeid NVARCHAR(128) NULL,
           probeargs NVARCHAR(128) NULL, 
           probevalue NVARCHAR(255) NULL,
           probelabel NVARCHAR(128) NULL,
           severity NVARCHAR(128) NULL,
           mgednode NVARCHAR(128) NULL,
           eehost NVARCHAR(128) NULL,
           ostype INT NULL,
           endpointtmr NVARCHAR(128) NULL,
           endpointtcphostname NVARCHAR(128) NULL,
           disposition NVARCHAR(128) NULL,
           eventtime int NULL,
           time DATETIME NULL)

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'U' AND name = 'GEM_Options')
  IF EXISTS (SELECT * FROM GEM_Options WHERE _Option = 'trace events' AND _Value = 'yes') BEGIN

    INSERT INTO GEM_APMTHRMsgs (class, hostname, origin, suborigin, source, subsource, adapterhostname, 
                                probeid, probeargs, probevalue, probelabel, severity,  mgednode, eehost, 
                                ostype, endpointtmr, endpointtcphostname, disposition, eventtime, time)
      VALUES (@class, 
	@hostname_slot,
	@origin,
	@suborigin,
	@source,
	@subsource,
	@adapterhost,
	@probeid,
	@probeargs, 
	@probevalue, 
	@probelabel, 
	@severity, 
	@mgednode,
	@eehost,
	@ostype,
        @endpointtmr,
        @endpointtcphostname,
	@disposition,
        @eventtime,
        GETDATE()
		)
  END

getout: 
-- commit transaction
IF @tcount = 0 
  COMMIT TRAN gemsp_processAPMThresholdMsg

GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

