IF EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[dbo].[gemsp_processAllEvent]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[gemsp_processAllEvent]
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE [gemsp_processAllEvent] 
		@lastrec INT, 
		@recnum INT, 
		@id INT, 
		@slotname NVARCHAR(255),
		@slotvalue NVARCHAR(255),
		@processed INT, 
		@hostos INT,
		@tcphostname NVARCHAR(255)='',
		@eehost NVARCHAR(255)=''
		
AS
  RAISERROR('gemsp_processAllEvent: @lastrec=%d, @recnum=%d, @id=%d, @slotname=%s, @slotvalue=%s, 
	    @processed=%d, @hostos=%d, @tcphostname=%s, @eehost=%s', 0, 1, 
  	    @lastrec, @recnum, @id, @slotname, @slotvalue, @processed, @hostos, @tcphostname, @eehost)

  -- Standard transaction logic
  DECLARE @tcount INT
  SELECT @tcount = @@TRANCOUNT
  IF @tcount = 0
    BEGIN TRAN gemsp_processAllEvent
  ELSE
    SAVE TRAN gemsp_processAllEvent

 IF NOT EXISTS (SELECT * FROM sysobjects WHERE type ='U' AND name = 'TEC_ALLEVENTS')
      CREATE TABLE TEC_ALLEVENTS
        (
		LastRecordIndicator INT NULL,  
		RecordNumber INT NULL, 
		RecordID INT NULL, 
		SlotName NVARCHAR(255) NULL, 
		SlotValue NVARCHAR(255) NULL, 
		ProcessedbyGEM INT NULL,
		ostype INT, 
		tcpiphostname NVARCHAR(255) NULL, 
		eehost NVARCHAR(255) NULL,
		time DATETIME NULL)

    INSERT INTO TEC_ALLEVENTS (LastRecordIndicator, RecordNumber, RecordID, SlotName, SlotValue, ProcessedbyGEM,  ostype, tcpiphostname, eehost,  time)
      VALUES (	@lastrec, 
		@recnum, 
		@id,
		@slotname,
		@slotvalue,
		@processed,
		@hostos,
		@tcphostname,
		@eehost,
	GETDATE()
		)

  -- commit transaction
  IF @tcount = 0 
    COMMIT TRAN gemsp_processAllEvent

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

